/*
ssc (static site checker)
Copyright (c) 2020-2022 Dylan Harris
https://dylanharris.org/

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public Licence as published by
the Free Software Foundation, either version 3 of the Licence,  or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public Licence for more details.

You should have received a copy of the GNU General Public
Licence along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#pragma once

struct sz_nullptr { constexpr static char const* sz () { return nullptr; } };

struct sz_EMPTY { constexpr static char const* sz () { return ""; } };
struct sz_0 { constexpr static char const* sz () { return "0"; } };
struct sz_1 { constexpr static char const* sz () { return "1"; } };
struct sz_1_0 { constexpr static char const* sz () { return "1.0"; } };
struct sz_1_1 { constexpr static char const* sz () { return "1.1"; } };
struct sz_1_2 { constexpr static char const* sz () { return "1.2"; } };
struct sz_2_0 { constexpr static char const* sz () { return "2.0"; } };
struct sz__blank { constexpr static char const* sz () { return "_blank"; } };
struct sz__parent { constexpr static char const* sz () { return "_parent"; } };
struct sz__self { constexpr static char const* sz () { return "_self"; } };
struct sz__top { constexpr static char const* sz () { return "_top"; } };
struct sz_a { constexpr static char const* sz () { return "A"; } };
struct sz_abbrev { constexpr static char const* sz () { return "abbrev"; } };
struct sz_above { constexpr static char const* sz () { return "above"; } };
struct sz_accesskey { constexpr static char const* sz () { return "accesskey"; } };
struct sz_after { constexpr static char const* sz () { return "after"; } };
struct sz_all { constexpr static char const* sz () { return "all"; } };
struct sz_align { constexpr static char const* sz () { return "align"; } };
struct sz_alternate { constexpr static char const* sz () { return "alternate"; } };
struct sz_always { constexpr static char const* sz () { return "always"; } };
struct sz_anonymous { constexpr static char const* sz () { return "anonymous"; } };
struct sz_appointment { constexpr static char const* sz () { return "appointment"; } };
struct sz_app_urlencoded { constexpr static char const* sz () { return "application/x-www-form-urlencoded"; } };
struct sz_ascending { constexpr static char const* sz () { return "ascending"; } };
struct sz_assertive { constexpr static char const* sz () { return "assertive"; } };
struct sz_async { constexpr static char const* sz () { return "async"; } };
struct sz_auto { constexpr static char const* sz () { return "auto"; } };
struct sz_autoreverse { constexpr static char const* sz () { return "auto-reverse"; } };
struct sz_b { constexpr static char const* sz () { return "B"; } };
struct sz_baseline { constexpr static char const* sz () { return "baseline"; } };
struct sz_basic { constexpr static char const* sz () { return "basic"; } };
struct sz_before { constexpr static char const* sz () { return "before"; } };
struct sz_below { constexpr static char const* sz () { return "below"; } };
struct sz_bevel { constexpr static char const* sz () { return "bevel"; } };
struct sz_block { constexpr static char const* sz () { return "block"; } };
struct sz_bold { constexpr static char const* sz () { return "bold"; } };
struct sz_both { constexpr static char const* sz () { return "both"; } };
struct sz_bottom { constexpr static char const* sz () { return "bottom"; } };
struct sz_bubble { constexpr static char const* sz () { return "bubble"; } };
struct sz_butt { constexpr static char const* sz () { return "butt"; } };
struct sz_button { constexpr static char const* sz () { return "button"; } };
struct sz_bytes { constexpr static char const* sz () { return "bytes"; } };
struct sz_cancel { constexpr static char const* sz () { return "cancel"; } };
struct sz_cancelled { constexpr static char const* sz () { return "cancelled"; } };
struct sz_canslip { constexpr static char const* sz () { return "canSlip"; } };
struct sz_capture { constexpr static char const* sz () { return "capture"; } };
struct sz_centre { constexpr static char const* sz () { return "center"; } };
struct sz_cc_attribution { constexpr static char const* sz () { return "cc:Attribution"; } };
struct sz_cc_commercialuse { constexpr static char const* sz () { return "cc:CommercialUse"; } };
struct sz_cc_derivativeworks { constexpr static char const* sz () { return "cc:DerivativeWorks"; } };
struct sz_cc_distribution { constexpr static char const* sz () { return "cc:Distribution"; } };
struct sz_cc_notice  { constexpr static char const* sz () { return "cc:Notice "; } };
struct sz_cc_reproduction { constexpr static char const* sz () { return "cc:Reproduction"; } };
struct sz_cc_sharealike { constexpr static char const* sz () { return "cc:ShareAlike"; } };
struct sz_cc_sourcecode { constexpr static char const* sz () { return "cc:SourceCode"; } };
struct sz_characters { constexpr static char const* sz () { return "characters"; } };
struct sz_checkbox { constexpr static char const* sz () { return "checkbox"; } };
struct sz_circle { constexpr static char const* sz () { return "circle"; } };
struct sz_changed { constexpr static char const* sz () { return "changed"; } };
struct sz_classic { constexpr static char const* sz () { return "classic"; } };
struct sz_closed { constexpr static char const* sz () { return "closed"; } };
struct sz_closedopen { constexpr static char const* sz () { return "closed-open"; } };
struct sz_col { constexpr static char const* sz () { return "col"; } };
struct sz_colgroup { constexpr static char const* sz () { return "colgroup"; } };
struct sz_collapse { constexpr static char const* sz () { return "collapse"; } };
struct sz_colon { constexpr static char const* sz () { return ":"; } };
struct sz_colondot { constexpr static char const* sz () { return ":."; } };
struct sz_colonspace { constexpr static char const* sz () { return ": "; } };
struct sz_comma { constexpr static char const* sz () { return ","; } };
struct sz_commaspace { constexpr static char const* sz () { return ", "; } };
struct sz_command { constexpr static char const* sz () { return "command"; } };
struct sz_compress { constexpr static char const* sz () { return "compress"; } };
struct sz_conference { constexpr static char const* sz () { return "conference"; } };
struct sz_confidential { constexpr static char const* sz () { return "confidential"; } };
struct sz_confirmed { constexpr static char const* sz () { return "confirmed"; } };
struct sz_context { constexpr static char const* sz () { return "context"; } };
struct sz_continue { constexpr static char const* sz () { return "continue"; } };
struct sz_cross_origin { constexpr static char const* sz () { return "cross-origin"; } };
struct sz_CSS { constexpr static char const* sz () { return "CSS"; } };
struct sz_currentcolour { constexpr static char const* sz () { return "currentColor"; } };
struct sz_dashed { constexpr static char const* sz () { return "dashed"; } };
struct sz_data { constexpr static char const* sz () { return "data"; } };
struct sz_decimal { constexpr static char const* sz () { return "decimal"; } };
struct sz_decimalpoint { constexpr static char const* sz () { return "decimalpoint"; } };
struct sz_decoding { constexpr static char const* sz () { return "decoding"; } };
struct sz_default { constexpr static char const* sz () { return "default"; } };
struct sz_defer { constexpr static char const* sz () { return "defer"; } };
struct sz_deflate { constexpr static char const* sz () { return "deflate"; } };
struct sz_deleted { constexpr static char const* sz () { return "deleted"; } };
struct sz_descending { constexpr static char const* sz () { return "descending"; } };
struct sz_dialog { constexpr static char const* sz () { return "dialog"; } };
struct sz_dilate { constexpr static char const* sz () { return "dilate"; } };
struct sz_disable { constexpr static char const* sz () { return "disable"; } };
struct sz_disc { constexpr static char const* sz () { return "disc"; } };
struct sz_discard { constexpr static char const* sz () { return "discard"; } };
struct sz_discrete { constexpr static char const* sz () { return "discrete"; } };
struct sz_display { constexpr static char const* sz () { return "display"; } };
struct sz_document { constexpr static char const* sz () { return "document"; } };
struct sz_down { constexpr static char const* sz () { return "down"; } };
struct sz_dsa { constexpr static char const* sz () { return "dsa"; } };
struct sz_dsssl { constexpr static char const* sz () { return "dsssl-lite"; } };
struct sz_duplicate { constexpr static char const* sz () { return "duplicate"; } };
struct sz_dynamic { constexpr static char const* sz () { return "dynamic"; } };
struct sz_eager { constexpr static char const* sz () { return "eager"; } };
struct sz_ec { constexpr static char const* sz () { return "ec"; } };
struct sz_echomsg { constexpr static char const* sz () { return "echomsg"; } };
struct sz_elide { constexpr static char const* sz () { return "elide"; } };
struct sz_ellipse { constexpr static char const* sz () { return "ellipse"; } };
struct sz_embed { constexpr static char const* sz () { return "embed"; } };
struct sz_en { constexpr static char const* sz () { return "en"; } };
struct sz_enable { constexpr static char const* sz () { return "enable"; } };
struct sz_end { constexpr static char const* sz () { return "end"; } };
struct sz_encoding { constexpr static char const* sz () { return "encoding"; } };
struct sz_environment { constexpr static char const* sz () { return "environment"; } };
struct sz_erode { constexpr static char const* sz () { return "erode"; } };
struct sz_errmsg { constexpr static char const* sz () { return "errmsg"; } };
struct sz_evenodd { constexpr static char const* sz () { return "evenodd"; } };
struct sz_exact { constexpr static char const* sz () { return "exact"; } };
struct sz_expo { constexpr static char const* sz () { return "expo"; } };
struct sz_false { constexpr static char const* sz () { return "false"; } };
struct sz_female { constexpr static char const* sz () { return "female"; } };
struct sz_file { constexpr static char const* sz () { return "file"; } };
struct sz_fill { constexpr static char const* sz () { return "fill"; } };
struct sz_fillpaint { constexpr static char const* sz () { return "fillPaint"; } };
struct sz_fit { constexpr static char const* sz () { return "fit"; } };
struct sz_float { constexpr static char const* sz () { return "float"; } };
struct sz_forwardonly { constexpr static char const* sz () { return "forwardOnly"; } };
struct sz_freeze { constexpr static char const* sz () { return "freeze"; } };
struct sz_fs { constexpr static char const* sz () { return "fs"; } };
struct sz_full { constexpr static char const* sz () { return "full"; } };
struct sz_functionmodel { constexpr static char const* sz () { return "function-model"; } };
struct sz_g { constexpr static char const* sz () { return "G"; } };
struct sz_get { constexpr static char const* sz () { return "get"; } };
struct sz_gamma { constexpr static char const* sz () { return "gamma"; } };
struct sz_global { constexpr static char const* sz () { return "global"; } };
struct sz_grammar { constexpr static char const* sz () { return "grammar"; } };
struct sz_group { constexpr static char const* sz () { return "group"; } };
struct sz_gzip { constexpr static char const* sz () { return "gzip"; } };
struct sz_h { constexpr static char const* sz () { return "h"; } };
struct sz_hard { constexpr static char const* sz () { return "hard"; } };
struct sz_hash { constexpr static char const* sz () { return "#"; } };
struct sz_hidden { constexpr static char const* sz () { return "hidden"; } };
struct sz_high { constexpr static char const* sz () { return "high"; } };
struct sz_highlight { constexpr static char const* sz () { return "highlight"; } };
struct sz_home { constexpr static char const* sz () { return "home"; } };
struct sz_horiz { constexpr static char const* sz () { return "horiz"; } };
struct sz_horizontal { constexpr static char const* sz () { return "horizontal"; } };
struct sz_host { constexpr static char const* sz () { return "host"; } };
struct sz_html { constexpr static char const* sz () { return "html"; } };
struct sz_huge { constexpr static char const* sz () { return "huge"; } };
struct sz_identity { constexpr static char const* sz () { return "identity"; } };
struct sz_in_stock { constexpr static char const* sz () { return "in_stock"; } };
struct sz_indefinite { constexpr static char const* sz () { return "indefinite"; } };
struct sz_independent { constexpr static char const* sz () { return "independent"; } };
struct sz_indentalign { constexpr static char const* sz () { return "indentalign"; } };
struct sz_indentshift { constexpr static char const* sz () { return "indentshift"; } };
struct sz_individual { constexpr static char const* sz () { return "individual"; } };
struct sz_infinity { constexpr static char const* sz () { return "infinity"; } };
struct sz_infixlinebreakstyle { constexpr static char const* sz () { return "infixlinebreakstyle"; } };
struct sz_infix { constexpr static char const* sz () { return "infix"; } };
struct sz_inherit { constexpr static char const* sz () { return "inherit"; } };
struct sz_initial { constexpr static char const* sz () { return "initial"; } };
struct sz_inline { constexpr static char const* sz () { return "inline"; } };
struct sz_inserted { constexpr static char const* sz () { return "inserted"; } };
struct sz_instore_only { constexpr static char const* sz () { return "instore_only"; } };
struct sz_interested { constexpr static char const* sz () { return "interested"; } };
struct sz_irrelevant { constexpr static char const* sz () { return "irrelevant"; } };
struct sz_isolated { constexpr static char const* sz () { return "isolated"; } };
struct sz_italic { constexpr static char const* sz () { return "italic"; } };
struct sz_json { constexpr static char const* sz () { return "json"; } };
struct sz_justify { constexpr static char const* sz () { return "justify"; } };
struct sz_keep { constexpr static char const* sz () { return "keep"; } };
struct sz_knockout { constexpr static char const* sz () { return "knockout"; } };
struct sz_large { constexpr static char const* sz () { return "large"; } };
struct sz_lazy { constexpr static char const* sz () { return "lazy"; } };
struct sz_left { constexpr static char const* sz () { return "left"; } };
struct sz_leftoverlap { constexpr static char const* sz () { return "leftoverlap"; } };
struct sz_lexicographic { constexpr static char const* sz () { return "lexicographic"; } };
struct sz_linear { constexpr static char const* sz () { return "linear"; } };
struct sz_line { constexpr static char const* sz () { return "line"; } };
struct sz_list { constexpr static char const* sz () { return "list"; } };
struct sz_local { constexpr static char const* sz () { return "local"; } };
struct sz_location { constexpr static char const* sz () { return "location"; } };
struct sz_locked { constexpr static char const* sz () { return "locked"; } };
struct sz_loose { constexpr static char const* sz () { return "loose"; } };
struct sz_low { constexpr static char const* sz () { return "low"; } };
struct sz_ltr { constexpr static char const* sz () { return "ltr"; } };
struct sz_lro { constexpr static char const* sz () { return "lro"; } };
struct sz_magnify { constexpr static char const* sz () { return "magnify"; } };
struct sz_makeapp { constexpr static char const* sz () { return "makeapp"; } };
struct sz_male { constexpr static char const* sz () { return "male"; } };
struct sz_markers { constexpr static char const* sz () { return "markers"; } };
struct sz_maybe { constexpr static char const* sz () { return "maybe"; } };
struct sz_media { constexpr static char const* sz () { return "media"; } };
struct sz_medial { constexpr static char const* sz () { return "medial"; } };
struct sz_medium { constexpr static char const* sz () { return "medium"; } };
struct sz_meet { constexpr static char const* sz () { return "meet"; } };
struct sz_meeting { constexpr static char const* sz () { return "meeting"; } };
struct sz_metadata { constexpr static char const* sz () { return "metadata"; } };
struct sz_middle { constexpr static char const* sz () { return "middle"; } };
struct sz_miter { constexpr static char const* sz () { return "miter"; } };
struct sz_mixed { constexpr static char const* sz () { return "mixed"; } };
struct sz_module { constexpr static char const* sz () { return "module"; } };
struct sz_moved { constexpr static char const* sz () { return "moved"; } };
struct sz_multipart_form_data { constexpr static char const* sz () { return "multipart/form-data"; } };
struct sz_multiset { constexpr static char const* sz () { return "multiset"; } };
struct sz_never { constexpr static char const* sz () { return "never"; } };
struct sz_new { constexpr static char const* sz () { return "new"; } };
struct sz_no { constexpr static char const* sz () { return "no"; } };
struct sz_nodownload { constexpr static char const* sz () { return "nodownload"; } };
struct sz_nofullscreen { constexpr static char const* sz () { return "nofullscreen"; } };
struct sz_none { constexpr static char const* sz () { return "none"; } };
struct sz_nonscalingstroke { constexpr static char const* sz () { return "non-scaling-stroke"; } };
struct sz_nonzero { constexpr static char const* sz () { return "nonzero"; } };
struct sz_noremoteplayback { constexpr static char const* sz () { return "noremoteplayback"; } };
struct sz_normal { constexpr static char const* sz () { return "normal"; } };
struct sz_nosniff { constexpr static char const* sz () { return "nosniff"; } };
struct sz_nostitch { constexpr static char const* sz () { return "noStitch"; } };
struct sz_numeric { constexpr static char const* sz () { return "numeric"; } };
struct sz_object { constexpr static char const* sz () { return "object"; } };
struct sz_object_bbox { constexpr static char const* sz () { return "object-bbox"; } };
struct sz_objectboundingbox { constexpr static char const* sz () { return "objectBoundingBox"; } };
struct sz_oblique { constexpr static char const* sz () { return "oblique"; } };
struct sz_off { constexpr static char const* sz () { return "off"; } };
struct sz_on { constexpr static char const* sz () { return "on"; } };
struct sz_onerror { constexpr static char const* sz () { return "onerror"; } };
struct sz_ondefine { constexpr static char const* sz () { return "onDefine"; } };
struct sz_onload { constexpr static char const* sz () { return "onLoad"; } };
struct sz_onrequest { constexpr static char const* sz () { return "onRequest"; } };
struct sz_onstart { constexpr static char const* sz () { return "onStart"; } };
struct sz_onuse { constexpr static char const* sz () { return "onUse"; } };
struct sz_opaque { constexpr static char const* sz () { return "opaque"; } };
struct sz_open { constexpr static char const* sz () { return "open"; } };
struct sz_openclosed { constexpr static char const* sz () { return "open-closed"; } };
struct sz_optimisespeed { constexpr static char const* sz () { return "optimizeSpeed"; } };
struct sz_optimisequality { constexpr static char const* sz () { return "optimizeQuality"; } };
struct sz_organisation { constexpr static char const* sz () { return "organization"; } };
struct sz_other { constexpr static char const* sz () { return "other"; } };
struct sz_out_of_stock { constexpr static char const* sz () { return "out_of_stock"; } };
struct sz_overlay { constexpr static char const* sz () { return "overlay"; } };
struct sz_paced { constexpr static char const* sz () { return "paced"; } };
struct sz_pad { constexpr static char const* sz () { return "pad"; } };
struct sz_perform { constexpr static char const* sz () { return "perform"; } };
struct sz_pixels { constexpr static char const* sz () { return "pixels"; } };
struct sz_plaintext { constexpr static char const* sz () { return "plaintext"; } };
struct sz_polite { constexpr static char const* sz () { return "polite"; } };
struct sz_poly { constexpr static char const* sz () { return "poly"; } };
struct sz_polygon { constexpr static char const* sz () { return "polygon"; } };
struct sz_popup { constexpr static char const* sz () { return "popup"; } };
struct sz_post { constexpr static char const* sz () { return "post"; } };
struct sz_postfix { constexpr static char const* sz () { return "postfix"; } };
struct sz_prefix { constexpr static char const* sz () { return "prefix"; } };
struct sz_preorder { constexpr static char const* sz () { return "preorder"; } };
struct sz_preserve { constexpr static char const* sz () { return "preserve"; } };
struct sz_private { constexpr static char const* sz () { return "private"; } };
struct sz_public { constexpr static char const* sz () { return "public"; } };
struct sz_r { constexpr static char const* sz () { return "R"; } };
struct sz_radio { constexpr static char const* sz () { return "radio"; } };
struct sz_rect { constexpr static char const* sz () { return "rect"; } };
struct sz_ref { constexpr static char const* sz () { return "ref"; } };
struct sz_reflect { constexpr static char const* sz () { return "reflect"; } };
struct sz_refurbished { constexpr static char const* sz () { return "refurbished"; } };
struct sz_relative { constexpr static char const* sz () { return "relative"; } };
struct sz_relevant { constexpr static char const* sz () { return "relevant"; } };
struct sz_remove { constexpr static char const* sz () { return "remove"; } };
struct sz_render { constexpr static char const* sz () { return "render"; } };
struct sz_repeat { constexpr static char const* sz () { return "repeat"; } };
struct sz_replace { constexpr static char const* sz () { return "replace"; } };
struct sz_reset { constexpr static char const* sz () { return "reset"; } };
struct sz_right { constexpr static char const* sz () { return "right"; } };
struct sz_rightoverlap { constexpr static char const* sz () { return "rightoverlap"; } };
struct sz_round { constexpr static char const* sz () { return "round"; } };
struct sz_row { constexpr static char const* sz () { return "row"; } };
struct sz_rowgroup { constexpr static char const* sz () { return "rowgroup"; } };
struct sz_rs232 { constexpr static char const* sz () { return "rs232"; } };
struct sz_rsa { constexpr static char const* sz () { return "rsa"; } };
struct sz_rlo { constexpr static char const* sz () { return "rlo"; } };
struct sz_rtl { constexpr static char const* sz () { return "rtl"; } };
struct sz_same_origin { constexpr static char const* sz () { return "same-origin"; } };
struct sz_same_site { constexpr static char const* sz () { return "same-site"; } };
struct sz_scale { constexpr static char const* sz () { return "scale"; } };
struct sz_scroll { constexpr static char const* sz () { return "scroll"; } };
struct sz_screen { constexpr static char const* sz () { return "screen"; } };
struct sz_self { constexpr static char const* sz () { return "self"; } };
struct sz_semicolon { constexpr static char const* sz () { return ";"; } };
struct sz_sentences { constexpr static char const* sz () { return "sentences"; } };
struct sz_simple { constexpr static char const* sz () { return "simple"; } };
struct sz_sizefmt { constexpr static char const* sz () { return "sizefmt"; } };
struct sz_slice { constexpr static char const* sz () { return "slice"; } };
struct sz_slide { constexpr static char const* sz () { return "slide"; } };
struct sz_smallcaps { constexpr static char const* sz () { return "small-caps"; } };
struct sz_soft { constexpr static char const* sz () { return "soft"; } };
struct sz_solid { constexpr static char const* sz () { return "solid"; } };
struct sz_space { constexpr static char const* sz () { return " "; } };
struct sz_space_comma { constexpr static char const* sz () { return " ,"; } };
struct sz_spaced { constexpr static char const* sz () { return "spaced"; } };
struct sz_spacing { constexpr static char const* sz () { return "spacing"; } };
struct sz_spacingandglyphs { constexpr static char const* sz () { return "spacingAndGlyphs"; } };
struct sz_spelling { constexpr static char const* sz () { return "spelling"; } };
struct sz_spline { constexpr static char const* sz () { return "spline"; } };
struct sz_square { constexpr static char const* sz () { return "square"; } };
struct sz_srgb { constexpr static char const* sz () { return "sRGB"; } };
struct sz_start { constexpr static char const* sz () { return "start"; } };
struct sz_static { constexpr static char const* sz () { return "static"; } };
struct sz_statusline { constexpr static char const* sz () { return "statusline"; } };
struct sz_stick { constexpr static char const* sz () { return "stick"; } };
struct sz_stitch { constexpr static char const* sz () { return "stitch"; } };
struct sz_stop { constexpr static char const* sz () { return "stop"; } };
struct sz_stretch { constexpr static char const* sz () { return "stretch"; } };
struct sz_stroke { constexpr static char const* sz () { return "stroke"; } };
struct sz_strokepaint { constexpr static char const* sz () { return "strokePaint"; } };
struct sz_strokewidth { constexpr static char const* sz () { return "strokeWidth"; } };
struct sz_structured_text { constexpr static char const* sz () { return "structured text"; } };
struct sz_sub { constexpr static char const* sz () { return "sub"; } };
struct sz_submit { constexpr static char const* sz () { return "submit"; } };
struct sz_sum { constexpr static char const* sz () { return "sum"; } };
struct sz_super { constexpr static char const* sz () { return "super"; } };
struct sz_svg { constexpr static char const* sz () { return "svg"; } };
struct sz_sync { constexpr static char const* sz () { return "sync"; } };
struct sz_table { constexpr static char const* sz () { return "table"; } };
struct sz_text { constexpr static char const* sz () { return "text"; } };
struct sz_text_plain { constexpr static char const* sz () { return "text/plain"; } };
struct sz_timefmt { constexpr static char const* sz () { return "timefmt"; } };
struct sz_tiny { constexpr static char const* sz () { return "tiny"; } };
struct sz_target { constexpr static char const* sz () { return "target"; } };
struct sz_tentative { constexpr static char const* sz () { return "tentative"; } };
struct sz_terminal { constexpr static char const* sz () { return "terminal"; } };
struct sz_tight { constexpr static char const* sz () { return "tight"; } };
struct sz_toggle { constexpr static char const* sz () { return "toggle"; } };
struct sz_toolbar { constexpr static char const* sz () { return "toolbar"; } };
struct sz_tooltip { constexpr static char const* sz () { return "tooltip"; } };
struct sz_top { constexpr static char const* sz () { return "top"; } };
struct sz_transparent { constexpr static char const* sz () { return "transparent"; } };
struct sz_triangle { constexpr static char const* sz () { return "triangle"; } };
struct sz_true { constexpr static char const* sz () { return "true"; } };
struct sz_truncate { constexpr static char const* sz () { return "truncate"; } };
struct sz_turbulence { constexpr static char const* sz () { return "turbulence"; } };
struct sz_twosided { constexpr static char const* sz () { return "two-sided"; } };
struct sz_undefined { constexpr static char const* sz () { return "undefined"; } };
struct sz_up { constexpr static char const* sz () { return "up"; } };
struct sz_until_found { constexpr static char const* sz () { return "until-found"; } };
struct sz_url { constexpr static char const* sz () { return "url"; } };
struct sz_usb { constexpr static char const* sz () { return "usb"; } };
struct sz_use_credentials { constexpr static char const* sz () { return "use-credentials"; } };
struct sz_used { constexpr static char const* sz () { return "used"; } };
struct sz_user { constexpr static char const* sz () { return "user"; } };
struct sz_userspace { constexpr static char const* sz () { return "userspace"; } };
struct sz_userspaceonuse { constexpr static char const* sz () { return "userSpaceOnUse"; } };
struct sz_v { constexpr static char const* sz () { return "v"; } };
struct sz_value { constexpr static char const* sz () { return "value"; } };
struct sz_var { constexpr static char const* sz () { return "var"; } };
struct sz_vert { constexpr static char const* sz () { return "vert"; } };
struct sz_vertical { constexpr static char const* sz () { return "vertical"; } };
struct sz_viewport { constexpr static char const* sz () { return "viewport"; } };
struct sz_virtual { constexpr static char const* sz () { return "virtual"; } };
struct sz_visible { constexpr static char const* sz () { return "visible"; } };
struct sz_w3c { constexpr static char const* sz () { return "w3c-style"; } };
struct sz_wallclock { constexpr static char const* sz () { return "wallclock"; } };
struct sz_whennotactive { constexpr static char const* sz () { return "whenNotActive"; } };
struct sz_whenstarted { constexpr static char const* sz () { return "whenStarted"; } };
struct sz_words { constexpr static char const* sz () { return "words"; } };
struct sz_work { constexpr static char const* sz () { return "work"; } };
struct sz_wrap { constexpr static char const* sz () { return "wrap"; } };
struct sz_XML { constexpr static char const* sz () { return "XML"; } };
struct sz_yes { constexpr static char const* sz () { return "yes"; } };
struct sz_zoom { constexpr static char const* sz () { return "zoom"; } };
