﻿/*
ssc (static site checker)
Copyright (c) 2020-2022 Dylan Harris
https://dylanharris.org/

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public Licence as published by
the Free Software Foundation, either version 3 of the Licence,  or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public Licence for more details.

You should have received a copy of the GNU General Public
Licence along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#include "main/standard.h"
#include "parser/text-data.h"

wotsit_t wotsit_table [] =
{   { { HTML_1_0 }, { HTML_UNDEF }, u8"AElig", NOFLAGS, u8"AE" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Aacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Abreve" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Acirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Acy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Afr" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"Agr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Agrave" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Alpha" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Amacr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"And" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Aogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Aopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"ApplyFunction" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Aring" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ascr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Assign" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Atilde" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Auml" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Backslash" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"BadBreak" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Barv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Barwed" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Bcy" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Because" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Bernoullis" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Beta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Bfr" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"Bgr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Bopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Breve" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Bscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Bumpeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"CHcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"COPY" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Cacute" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Cap" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"CapitalDifferentialD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Cayleys" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ccaron" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Ccedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ccirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Cconint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Cdot" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Cedilla" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"CenterDot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Cfr" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Chi" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"CircleDot" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"CircleMinus" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"CirclePlus" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"CircleTimes" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"ClockwiseContourIntegral" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"CloseCurlyDoubleQuote" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"CloseCurlyQuote" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Colon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Colone" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Congruent" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Conint" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"ContourIntegral" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Copf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Coproduct" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"CounterClockwiseContourIntegral" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Cross" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Cscr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Cup" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"CupCap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"DD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"DDotrahd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"DJcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"DScy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"DZcy" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Dagger" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"Darr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Dashv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Dcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Dcy" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Del" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"Delta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Dfr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DiacriticalAcute" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DiacriticalDot" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DiacriticalDoubleAcute" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DiacriticalGrave" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DiacriticalLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DiacriticalLeftRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DiacriticalLeftRightVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DiacriticalLeftVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DiacriticalRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DiacriticalRightVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DiacriticalTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Diamond" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DifferentialD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Dopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Dot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"DotDot" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DotEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleContourIntegral" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleDot" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleDownArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleLeftRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleLeftTee" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleLongLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleLongLeftRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleLongRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleRightTee" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleUpArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleUpDownArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DoubleVerticalBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DownArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DownArrowBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DownArrowUpArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DownBreve" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DownLeftRightVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DownLeftTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DownLeftVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DownLeftVectorBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DownRightTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DownRightVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DownRightVectorBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DownTee" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"DownTeeArrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Downarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Dscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Dstrok" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"EEgr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ENG" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"ETH" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Eacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ecaron" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Ecirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ecy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Edot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Efr" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"Egr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Egrave" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Element" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Emacr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"EmptySmallSquare" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"EmptyVerySmallSquare" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Eogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Eopf" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Epsilon" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Equal" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"EqualTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Equilibrium" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Escr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Esim" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Eta" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Euml" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Exists" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ExponentialE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Fcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ffr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"FilledSmallSquare" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"FilledVerySmallSquare" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Fopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"ForAll" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Fouriertrf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Fscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"GJcy" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"Gamma" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Gammad" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Gbreve" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Gcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Gcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Gcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Gdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Gfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Gg" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"GoodBreak" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Gopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"GreaterEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"GreaterEqualLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"GreaterFullEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"GreaterGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"GreaterLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"GreaterSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"GreaterTilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Gscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Gt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"HARDcy" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Hacek" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Hat" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Hcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Hfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"HilbertSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Hopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"HorizontalLine" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Hscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Hstrok" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"HumpDownHump" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"HumpEqual" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"IEcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"IJlig", NOFLAGS, u8"IJ" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"IOcy" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Iacute" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Icirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Icy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Idot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ifr" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"Igr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Igrave" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Im" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Imacr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ImaginaryI" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Implies" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"IndentingNewLine" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Int" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Integral" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Intersection" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"InvisibleComma" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"InvisibleTimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Iogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Iopf" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Iota" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Iscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Itilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Iukcy" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Iuml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Jcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Jcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Jfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Jopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Jscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Jsercy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Jukcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"KHcy" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"KHgr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"KJcy" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Kappa" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Kcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Kcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Kfr" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"Kgr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Kopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Kscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"LJcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Lacute" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"Lambda" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Lang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Laplacetrf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Larr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Lcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Lcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Lcy" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftAngleBracket" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftArrowBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftArrowRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftBracketingBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftCeiling" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftDoubleBracket" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftDoubleBracketingBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftDownTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftDownVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftDownVectorBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftFloor" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftRightVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftSkeleton" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftTee" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftTeeArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftTriangle" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftTriangleBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftTriangleEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftUpDownVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftUpTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftUpVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftUpVectorBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LeftVectorBar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Leftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Leftrightarrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LessEqualGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LessFullEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LessGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LessLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LessSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LessTilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Lfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ll" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Lleftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Lmidot" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LongLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LongLeftRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LongRightArrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Longleftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Longleftrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Longrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Lopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LowerLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"LowerRightArrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Lscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Lsh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Lstrok" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Lt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Map" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Mcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"MediumSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Mellintrf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Mfr" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"Mgr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"MinusPlus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Mopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Mscr" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Mu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"NJcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Nacute" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NaN" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ncaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ncedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ncy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"NegativeMediumSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"NegativeThickSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"NegativeThinSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"NegativeVeryThinSpace" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NestedGreaterGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NestedLessLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NewLine" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Nfr" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"Ngr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"NoBreak" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"NonBreakingSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Nopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Not" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotANumber" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotCongruent" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotCupCap" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotDoubleVerticalBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotElement" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotEqualTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotExists" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotGreaterEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotGreaterFullEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotGreaterGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotGreaterLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotGreaterSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotGreaterTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotHumpDownHump" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotHumpEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotLeftTriangle" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotLeftTriangleBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotLeftTriangleEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotLessEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotLessFullEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotLessGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotLessLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotLessSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotLessTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotNestedGreaterGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotNestedLessLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotPrecedes" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotPrecedesEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotPrecedesSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotPrecedesTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotReverseElement" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotRightTriangle" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotRightTriangleBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotRightTriangleEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotSquareSubset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotSquareSubsetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotSquareSuperset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotSquareSupersetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotSubset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotSubsetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotSucceeds" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotSucceedsEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotSucceedsSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotSucceedsTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotSuperset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotSupersetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotTildeEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotTildeFullEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotTildeTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"NotVerticalBar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Nscr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Ntilde" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Nu" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"OElig", NOFLAGS, u8"OE" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Oacute" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Ocirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ocy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Odblac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ofr" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"Ogr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Ograve" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Omacr" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"Omega" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Omicron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Oopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"OpenCurlyDoubleQuote" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"OpenCurlyQuote" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Or" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Oscr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Oslash" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Otilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Otimes" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Ouml" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"OverBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"OverBrace" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"OverBracket" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"OverParenthesis" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"PHgr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"PartialD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Pcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Pfr" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Phi" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"Pi" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"PlusMinus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Poincareplane" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Popf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Pr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Precedes" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"PrecedesEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"PrecedesSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"PrecedesTilde" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"Prime" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Product" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Proportion" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Proportional" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Pscr" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"Psi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"QUOT" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Qfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Qopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Qscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"RBarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"REG" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Racute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Rang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Rarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Rarrtl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Rcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Rcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Rcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Re" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"ReverseElement" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"ReverseEquilibrium" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"ReverseUpEquilibrium" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Rfr" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"Rgr" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Rho" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightAngleBracket" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightArrowBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightArrowLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightBracketingBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightCeiling" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightDoubleBracket" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightDoubleBracketingBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightDownTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightDownVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightDownVectorBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightFloor" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightSkeleton" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightTee" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightTeeArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightTriangle" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightTriangleBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightTriangleEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightUpDownVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightUpTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightUpVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightUpVectorBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RightVectorBar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Rightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ropf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"RoundImplies" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Rrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Rscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Rsh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"RuleDelayed" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"SHCHcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"SHcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"SOFTcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Sacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Sc" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Scaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Scedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Scirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Scy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Sfr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"ShortDownArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"ShortLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"ShortRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"ShortUpArrow" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"Sigma" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"SmallCircle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Sopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Space" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Sqrt" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Square" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"SquareIntersection" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"SquareSubset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"SquareSubsetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"SquareSuperset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"SquareSupersetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"SquareUnion" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Sscr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Star" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Sub" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Subset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"SubsetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Succeeds" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"SucceedsEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"SucceedsSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"SucceedsTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"SuchThat" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Sum" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Sup" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Superset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"SupersetEqual" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Supset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Tab" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"THORN" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"TRADE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"TSHcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"TScy" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Tau" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Tcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Tcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Tcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Tfr" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"Tgr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Therefore" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"Theta" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"ThinSpace" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"ThickSpace" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Tilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"TildeEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"TildeFullEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"TildeTilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Topf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"TripleDot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Tscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Tstrok" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Uacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Uarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Uarrocir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ubrcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ubreve" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Ucirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ucy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Udblac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ufr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Ugrave" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Umacr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UnderBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UnderBrace" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UnderBracket" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UnderParenthesis" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Union" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UnionPlus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Uogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Uopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UpArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UpArrowBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UpArrowDownArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UpDownArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UpEquilibrium" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UpTee" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UpTeeArrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Uparrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Updownarrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UpperLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"UpperRightArrow" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"Upsi" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Upsilon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Uring" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Uscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Utilde" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Uuml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"VDash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Vbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Vcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Vdash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Vdashl" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Vee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Verbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Vert" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"VerticalBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"VerticalLine" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"VerticalSeparator" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"VerticalTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"VeryThinSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Vfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Vopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Vscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Vvdash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Wcirc" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"Wedge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Wfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Wopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Wscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Xfr" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"Xi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Xopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Xscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"YAcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"YIcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"YUcy" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"Yacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ycirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Ycy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Yfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Yopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Yscr" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Yuml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ZHcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Zacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Zcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Zcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Zdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ZeroWidthSpace" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"Zeta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Zfr" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"Zgr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Zopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"Zscr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"aacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"abreve" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"acd" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"acirc" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"acute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"acy" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"aelig", NOFLAGS, u8"ae" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"af" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"afr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"agrave" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"alefsym" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"aleph" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"alpha" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"amacr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"amalg" },
    { { HTML_TAGS }, { HTML_UNDEF }, u8"amp", WOTSIT_XML, u8"&" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"and" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"andand" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"andd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"andslope" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"andv" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"ang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ange" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angmsd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angmsdaa" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angmsdab" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angmsdac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angmsdad" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angmsdae" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angmsdaf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angmsdag" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angmsdah" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angrt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angrtvb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angrtvbd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angsph" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angst" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"angzarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"aogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"aopf" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"ap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"apE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"apacir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ape" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"apid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"apos", WOTSIT_XML, u8"'" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"approx" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"approxeq" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"aring" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ascr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ast" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"asymp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"asympeq" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"atilde" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"auml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"awconint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"awint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bNot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"backcong" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"backepsilon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"backprime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"backsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"backsimeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"barvee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"barwed" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"barwedge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bbrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bbrktbrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bcong" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bcy" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"bdquo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"becaus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"because" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bemptyv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bepsi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bernou" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"beta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"beth" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"between" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bigcap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bigcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bigcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bigodot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bigoplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bigotimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bigsqcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bigstar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bigtriangledown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bigtriangleup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"biguplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bigvee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bigwedge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bkarow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"blacklozenge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"blacksquare" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"blacktriangle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"blacktriangledown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"blacktriangleleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"blacktriangleright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"blank" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"blk12" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"blk14" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"blk34" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"block" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bnot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bottom" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bowtie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxDL" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxDR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxDl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxDr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxH" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxHD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxHU" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxHd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxHu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxUL" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxUR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxUl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxUr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxV" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxVH" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxVL" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxVR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxVh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxVl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxVr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxbox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxdL" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxdR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxdl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxdr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxhD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxhU" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxhd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxhu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxminus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxtimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxuL" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxuR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxul" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxur" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxvH" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxvL" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxvR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxvh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxvl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"boxvr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bprime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"breve" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"brvbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bsemi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bsime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bsol" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bsolb" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"bull" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bullet" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bump" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bumpE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bumpe" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"bumpeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cacute" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"cap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"capand" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"capbrcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"capcap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"capcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"capdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"caret" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"caron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ccaps" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ccaron" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"ccedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ccirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ccups" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ccupssm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cdot" },
    { { HTML_3_0 }, { HTML_3_0 }, u8"cdots" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"cedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cemptyv" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"cent" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"centerdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"chcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"check" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"checkmark" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"chi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cirE" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"circ" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"circeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"circlearrowleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"circlearrowright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"circledR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"circledS" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"circledast" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"circledcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"circleddash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cire" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cirfnint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cirmid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cirscir" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"clubs" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"clubsuit" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"colon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"colone" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"coloneq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"comma" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"commat" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"comp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"compfn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"complement" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"complexes" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"cong" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"congdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"conint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"copf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"coprod" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"copy", NOFLAGS, u8"(c)" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"copysr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"cr" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"crarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cross" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"csub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"csube" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"csup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"csupe" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ctdot" },
    { { HTML_3_0 }, { HTML_3_0 }, u8"cub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cudarrl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cudarrr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cuepr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cuesc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cularr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cularrp" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"cup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cupbrcap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cupcap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cupcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cupdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cupor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"curarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"curarrm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"curlyeqprec" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"curlyeqsucc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"curlyvee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"curlywedge" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"curren" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"curvearrowleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"curvearrowright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cuvee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cuwed" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cwconint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cwint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"cylcty" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"dArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dHar" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"dagger" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"daleth" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"darr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dashv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dbkarow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dblac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dcy" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"dd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ddagger" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ddarr" },
    { { HTML_3_0 }, { HTML_3_0 }, u8"ddots" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ddotseq" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"deg" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"degree" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"delta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"demptyv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dfisht" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dharl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dharr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"diam" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"diamond" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"diamondsuit" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"diams" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"die" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"digamma" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"disin" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"div" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"divide" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"divideontimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"divonx" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"djcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dlcorn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dlcrop" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dollar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"doteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"doteqdot" },
    { { HTML_3_0 }, { HTML_3_0 }, u8"dotfill" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dotminus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dotplus" },
    { { HTML_3_0 }, { HTML_3_0 }, u8"dots" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dotsquare" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"doublebarwedge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"downarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"downdownarrows" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"downharpoonleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"downharpoonright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"drbkarow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"drcorn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"drcrop" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dscy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dsol" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dstrok" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dtdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dtri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dtrif" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"duarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"duhar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dwangle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dzcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"dzigrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eDDot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eDot" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"eacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"easter" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ecaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ecir" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"ecirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ecolon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ecy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"edot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"efDot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"efr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eg" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"egrave" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"egs" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"egsdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"el" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"elinters" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ell" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"els" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"elsdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"emacr" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"empty" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"emptyset" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"emptyv" },
    { { HTML_3_0, HV_NOT32 }, { HTML_UNDEF }, u8"emsp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"emsp13" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"emsp14" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eng" },
    { { HTML_3_0, HV_NOT32 }, { HTML_UNDEF }, u8"ensp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"epar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eparsl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eplus" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"epsi" },
    { { HTML_3_0 }, { HTML_UNDEF }, u8"epsilon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"epsiv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eqcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eqcolon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eqsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eqslantgtr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eqslantless" },
    { { HTML_3_0 }, { HTML_UNDEF }, u8"equals" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"equest" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"equiv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"equivDD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"eqvparsl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"erDot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"erarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"escr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"esdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"esim" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"eta" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"eth" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"euml" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"euro" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"excl" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"exist" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"expectation" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"exponentiale" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"fallingdotseq" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"false" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"fcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"female" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ffilig", NOFLAGS, u8"ffi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"fflig", NOFLAGS, u8"ff" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ffllig", NOFLAGS, u8"ffl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ffr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"filig", NOFLAGS, u8"fi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"flat" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"fllig", NOFLAGS, u8"fl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"fltns" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"fnof" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"fopf" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"forall" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"fork" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"forkv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"fpartint" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"frac12", NOFLAGS, u8"1/2" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"frac13", NOFLAGS, u8"1/3" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"frac14", NOFLAGS, u8"1/4" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"frac15", NOFLAGS, u8"1/5" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"frac16", NOFLAGS, u8"1/6" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"frac18", NOFLAGS, u8"1/8" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"frac23", NOFLAGS, u8"2/3" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"frac25", NOFLAGS, u8"2/5" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"frac34", NOFLAGS, u8"3/4" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"frac35", NOFLAGS, u8"3/5" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"frac38", NOFLAGS, u8"3/8" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"frac45", NOFLAGS, u8"4/5" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"frac56", NOFLAGS, u8"5/6" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"frac58", NOFLAGS, u8"5/8" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"frac78", NOFLAGS, u8"7/8" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"frasl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"frown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"fscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gEl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gacute" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"gamma" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gammad" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gbreve" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gdot" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"ge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gel" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"geq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"geqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"geqslant" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ges" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gescc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gesdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gesdoto" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gesdotol" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gesles" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ggg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gimel" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gjcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"glE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gla" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"glj" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gnE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gnap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gnapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gne" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gneq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gneqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gnsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"grave" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gsime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gsiml" },
    { { HTML_TAGS }, { HTML_UNDEF }, u8"gt", WOTSIT_XML, u8">" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gtcc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gtcir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gtdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gtlPar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gtquest" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gtrapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gtrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gtrdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gtreqless" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gtreqqless" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gtrless" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"gtrsim" },
    { { HTML_PLUS}, { HTML_UNDEF }, u8"hArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hairsp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"half" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hamilt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hardcy" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"harr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"harrcir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"harrw" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hcirc" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"hearts" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"heartsuit" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"hellip" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hercon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hksearow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hkswarow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hoarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"homtht" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hookleftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hookrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"horbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hslash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hstrok" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"ht" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hybull" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"hyphen" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"iacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ic" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"icirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"icy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"iecy" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"iexcl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"iff" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ifr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"igrave" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ii" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"iiiint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"iiint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"iinfin" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"iiota" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ijlig", NOFLAGS, u8"ij" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"imacr" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"image" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"imagline" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"imagpart" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"imath" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"imof" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"imped" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"in" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"incare" },
    { { HTML_3_0 }, { HTML_3_0 }, u8"inf" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"infin" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"infty" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"infintie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"inodot" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"int" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"intcal" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"integers" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"intercal" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"intlarhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"intprod" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"iocy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"iogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"iopf" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"iota" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"iprod" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"iquest" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"iscr" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"isin" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"isinE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"isindot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"isins" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"isinsv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"isinv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"it" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"itilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"iukcy" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"iuml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"jcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"jcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"jfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"jmath" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"jopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"jscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"jsercy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"jukcy" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"kappa" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"kappav" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"kcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"kcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"kfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"kgreen" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"khcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"kjcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"kopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"kscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lAarr" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"lArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lAtail" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lBarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lEg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lHar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"laemptyv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lagran" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"lambda" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"lang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"langd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"langle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lap" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"laquo", NOFLAGS, u8"<<"  },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"larr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"larrb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"larrbfs" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"larrfs" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"larrhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"larrlp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"larrpl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"larrsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"larrtl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lat" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"latail" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"late" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lbarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lbbrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lbrace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lbrack" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lbrke" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lbrksld" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lbrkslu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lcedil" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"lceil" },
    { { HTML_3_0 }, { HTML_UNDEF }, u8"lcub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ldca" },
    { { HTML_3_0 }, { HTML_3_0 }, u8"ldots" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"ldquo", NOFLAGS, u8"\"" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ldquor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ldrdhar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ldrushar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ldsh" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"le" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leftarrowtail" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leftharpoondown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leftharpoonup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leftleftarrows" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leftrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leftrightarrows" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leftrightharpoons" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leftrightsquigarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leftthreetimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"leqslant" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"les" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lescc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lesdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lesdoto" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lesdotor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lesges" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lessapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lessdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lesseqgtr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lesseqqgtr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lessgtr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lesssim" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"lf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lfisht" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"lfloor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lgE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lhard" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lharu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lharul" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lhblk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ljcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ll" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"llarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"llcorner" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"llhard" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lltri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lmidot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lmoust" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lmoustache" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lnE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lnap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lnapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lne" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lneq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lneqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lnsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"loang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"loarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lobrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"longleftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"longleftrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"longmapsto" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"longrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"looparrowleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"looparrowright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lopar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"loplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lotimes" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"lowast" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lowbar" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"loz" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lozenge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lozf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lpar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lparlt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lrcorner" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lrhar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lrhard" },
    { { HTML_2_0, HV_RFC_2070 | HV_NOT3 }, { HTML_UNDEF }, u8"lrm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lrtri" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"lsaquo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lsh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lsime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lsimg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lsqb" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"lsquo", NOFLAGS, u8"'" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lsquor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lstrok" },
    { { HTML_TAGS }, { HTML_UNDEF }, u8"lt", WOTSIT_XML, u8"<" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ltcc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ltcir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ltdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lthree" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ltimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ltlarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ltquest" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ltrPar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ltri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ltrie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ltrif" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"lurdshar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"luruhar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mDDot" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"macr" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"macron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"male" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"malt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"maltese" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"map" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mapsto" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mapstodown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mapstoleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mapstoup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"marker" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mcomma" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mcy" },
    { { HTML_3_0, HV_NOT32 }, { HTML_UNDEF }, u8"mdash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"measuredangle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mho" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"micro" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"midast" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"midcir" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"middot" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"minus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"minusb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"minusd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"minusdu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mlcp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mldr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mnplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"models" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mstpos" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"mu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"multimap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"mumap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nLeftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nLeftrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nRightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nVDash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nVdash" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"nabla" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"napos" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"napprox" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"nasymp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"natur" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"natural" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"naturals" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"nbsp", NOFLAGS, u8" " },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"nbump" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"nbumpe" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ncap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ncaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ncedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ncong" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ncup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ncy" },
    { { HTML_3_0, HV_NOT32 }, { HTML_UNDEF }, u8"ndash" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"ne" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"neArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nearhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nearr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nearrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nequiv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nesear" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"nesim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nexist" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nexists" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ngeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ngsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ngt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ngtr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nhArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nharr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nhpar" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"ni" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nis" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nisd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"niv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"njcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nlArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nlarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nldr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nleftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nleftrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nleq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nless" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nlsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nlt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nltri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nltrie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nmid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nopf" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"not" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"notin" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"notinva" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"notinvb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"notinvc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"notni" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"notniva" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"notnivb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"notnivc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"npar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nparallel" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"npolint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"npr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"npre" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nprcue" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nprec" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nrArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nrtri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nrtrie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsccue" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nshortmid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nshortparallel" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsimeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsmid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nspar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsqsube" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsqsupe" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"nsub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsube" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsubseteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsucc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsupe" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nsupseteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ntgl" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"ntilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ntlg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ntriangleleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ntrianglelefteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ntriangleright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ntrianglerighteq" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"nu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"num" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"numero" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"numsp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nvDash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nvHarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nvdash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nvinfin" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nvlArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nvrArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nwArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nwarhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nwarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nwarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"nwnear" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"oS" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"oacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"oast" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"obar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ocir" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"ocirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ocy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"odash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"odblac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"odiv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"odot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"odsold" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"oelig", NOFLAGS, u8"oe" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ofcir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ofr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ogon" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"ogr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"ograve" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ogt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ohbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ohm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"oint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"olarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"olcir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"olcross" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"oline" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"olt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"omacr" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"omega" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"omicron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"omid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ominus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"oopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"opar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"operp" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"oplus" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"or" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"orarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ord" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"order" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"orderof" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"ordf" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"ordm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"origof" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"oror" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"orslope" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"orv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"oscr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"oslash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"osol" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"otilde" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"otimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"otimesas" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"ouml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ovbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"par" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"para" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"parallel" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"parsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"parsl" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"part" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"pcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"percnt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"period" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"permil" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"perp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"pertenk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"pfr" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"phi" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"phis" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"phiv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"phmmat" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"phone" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"pi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"pitchfork" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"piv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"planck" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"planckh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"plankv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"plus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"plusacir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"plusb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"pluscir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"plusdo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"plusdu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"pluse" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"plusmn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"plussim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"plustwo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"pm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"pointint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"popf" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"pound" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"pr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"prE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"prap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"prcue" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"pre" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"prec" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"precapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"preccurlyeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"preceq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"precnapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"precneqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"precnsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"precsim" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"prime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"primes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"prnE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"prnap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"prnsim" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"prod" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"profalar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"profline" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"profsurf" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"prop" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"propto" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"prsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"prurel" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"pscr" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"psi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"puncsp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"qfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"qint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"qopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"qprime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"qscr" },
    { { HTML_3_0 }, { HTML_3_0 }, u8"quad" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"quaternions" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"quatint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"quest" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"questeq" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"quot", WOTSIT_XML, u8"\"" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rAarr" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"rArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rAtail" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rBarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rHar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"race" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"racute" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"radic" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"raemptyv" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"rang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rangd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"range" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rangle" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"raquo", NOFLAGS, u8">>" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"rarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rarrap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rarrb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rarrbfs" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rarrc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rarrfs" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rarrhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rarrlp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rarrpl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rarrsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rarrtl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rarrw" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ratail" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ratio" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rationals" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rbarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rbbrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rbrace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rbrack" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rbrke" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rbrksld" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rbrkslu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rcedil" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"rceil" },
    { { HTML_3_0 }, { HTML_UNDEF }, u8"rcub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rdca" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rdldhar" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"rdquo", NOFLAGS, u8"\"" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rdquor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rdsh" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"real" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"realine" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"realpart" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"reals" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rect" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"reg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rfisht" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"rfloor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rhard" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rharu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rharul" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"rho" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rhov" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rightarrowtail" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rightharpoondown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rightharpoonup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rightleftarrows" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rightleftharpoons" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rightrightarrows" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rightsquigarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rightthreetimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ring" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"risingdotseq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rlarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rlhar" },
    { { HTML_2_0, HV_RFC_2070 | HV_NOT3 }, { HTML_UNDEF }, u8"rlm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rmoust" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rmoustache" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rnmid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"roang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"roarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"robrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ropar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ropf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"roplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rotimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rpar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rpargt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rppolint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rrarr" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"rsaquo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rsh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rsqb" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"rsquo", NOFLAGS, u8"'" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rsquor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rthree" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rtimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rtri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rtrie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rtrif" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rtriltri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ruluhar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"rx" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sacute" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"sbquo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"scE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"scap" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"scaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sccue" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sce" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"scedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"scirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"scnE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"scnap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"scnsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"scpolint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"scsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"scy" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"sdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sdotb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sdote" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"seArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"searhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"searr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"searrow" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"sect" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"semi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"seswar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"setminus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"setmn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sext" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"sfgr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sfrown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sharp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"shchcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"shcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"shortmid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"shortparallel" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"shy" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"sigma" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"sigmaf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sigmav" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"sim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"simdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"simeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"simg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"simgE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"siml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"simlE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"simne" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"simplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"simrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"slarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"smallsetminus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"smashp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"smeparsl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"smid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"smile" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"smt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"smte" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"softcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sol", NOFLAGS, u8"/" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"solb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"solbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sopf" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"sp" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"spades" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"spadesuit" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"spar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"splat" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sqcap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sqcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sqsub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sqsube" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sqsubset" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sqsubseteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sqsup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sqsupe" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sqsupset" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sqsupseteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"squ" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"square" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"squarf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"squf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"squiggle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"srarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ssetmn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ssmile" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sstarf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"star" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"starf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"straightepsilon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"straightphi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"strns" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"sub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subdot" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"sube" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subedot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"submult" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subnE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subne" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subset" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subseteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subseteqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subsetneq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subsetneqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subsub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"subsup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"succ" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"succapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"succcurlyeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"succeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"succnapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"succneqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"succnsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"succsim" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"sum" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"sung" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"sup" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"sup1" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"sup2" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"sup3" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supdsub" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"supe" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supedot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"suphsub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"suplarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supmult" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supnE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supne" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supset" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supseteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supseteqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supsetneq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supsetneqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supsub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"supsup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"swArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"swarhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"swarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"swarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"swnwar" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"szlig", NOFLAGS, u8"sz" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"target" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"tau" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tbrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"telrec" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tfr" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"there4" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"therefore" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"theta" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"thetas" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"thetasym" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"thetav" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"thickapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"thicksim" },
    { { HTML_3_0, HV_NOT32 }, { HTML_UNDEF }, u8"thinsp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"thkap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"thksim" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"thorn" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"tilde" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"times" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"timesb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"timesbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"timesd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"toea" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"top" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"topbot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"topcir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"topf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"topfork" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tosa" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tprime" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"trade" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"triangle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"triangledown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"triangleleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"trianglelefteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"triangleq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"triangleright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"trianglerighteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tridot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"trie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"triminus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"triplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"trisb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tritime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"trpezium" },
    { { XHTML_1_0 }, { HTML_UNDEF }, u8"true" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tscy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tshcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"tstrok" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"twixt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"twoheadleftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"twoheadrightarrow" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"uArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"uHar" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"uacute" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"uarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ubrcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ubreve" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"ucirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ucy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"udarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"udblac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"udhar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ufisht" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ufr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"ugrave" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"uharl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"uharr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"uhblk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ulcorn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ulcorner" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ulcrop" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ultri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"umacr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"uml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"uogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"uopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"uparrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"updownarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"upharpoonleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"upharpoonright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"uplus" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"upsi" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"upsih" },
    { { HTML_4_0 }, { HTML_UNDEF }, u8"upsilon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"upuparrows" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"urcorn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"urcorner" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"urcrop" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"uring" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"urtri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"uscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"utdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"utilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"utri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"utrif" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"uuarr" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"uuml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"uwangle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vBar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vBarv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vDash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vangrt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"varepsilon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"varkappa" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"varnothing" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"varphi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"varpi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"varpropto" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"varr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"varrho" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"varsigma" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vartheta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vartriangleleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vartriangleright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vdash" },
    { { HTML_3_0 }, { HTML_3_0 }, u8"vdots" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"veebar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"veeeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vellip" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"verbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vert" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vltri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vopf" },
    { { HTML_PLUS }, { HTML_PLUS }, u8"vprime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vprop" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vrtri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"vzigzag" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"wcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"wedbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"wedge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"wedgeq" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"weierp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"wfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"wopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"wp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"wr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"wreath" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"wscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xcap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xdtri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xhArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xharr" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"xi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xlArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xlarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xmap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xnis" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xodot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xoplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xotime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xrArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xsqcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xuplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xutri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xvee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"xwedge" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"yacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"yacy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ycirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"ycy" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"yen" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"yfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"yicy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"yopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"yscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"yucy" },
    { { HTML_1_0 }, { HTML_UNDEF }, u8"yuml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"zacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"zcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"zcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"zdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"zeetrf" },
    { { HTML_PLUS }, { HTML_UNDEF }, u8"zeta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"zfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"zhcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"zigrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"zopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, u8"zscr" },
    { { HTML_2_0, HV_RFC_2070 | HV_NOT3 }, { HTML_UNDEF }, u8"zwj" },
    { { HTML_2_0, HV_RFC_2070 | HV_NOT3 }, { HTML_UNDEF }, u8"zwnj" },

    { { HTML_UNDEF }, { HTML_UNDEF }, nullptr } };

extra_t known_symbols [] =
{   { u8"Á", u8"Aacute" },
    { u8"á", u8"aacute" },
    { u8"Ă", u8"Abreve" },
    { u8"ă", u8"abreve" },
    { u8"∾", u8"ac" },
    { u8"∿", u8"acd" },
    { u8"∾̳", u8"acE" },
    { u8"Â", u8"Acirc" },
    { u8"â", u8"acirc" },
    { u8"´", u8"acute" },
    { u8"А", u8"Acy" },
    { u8"а", u8"acy" },
    { u8"Æ", u8"AElig" },
    { u8"æ", u8"aelig" },
    { u8"⁡", u8"af" },
    { u8"𝔄", u8"Afr" },
    { u8"𝔞", u8"afr" },
    { u8"À", u8"Agrave" },
    { u8"à", u8"agrave" },
    { u8"ℵ", u8"alefsym" },
    { u8"ℵ", u8"aleph" },
    { u8"Α", u8"Alpha" },
    { u8"α", u8"alpha" },
    { u8"Ā", u8"Amacr" },
    { u8"ā", u8"amacr" },
    { u8"⨿", u8"amalg" },
    { u8"&", u8"amp" },
    { u8"&", u8"AMP" },
    { u8"⩓", u8"And" },
    { u8"∧", u8"and" },
    { u8"⩕", u8"andand" },
    { u8"⩜", u8"andd" },
    { u8"⩘", u8"andslope" },
    { u8"⩚", u8"andv" },
    { u8"∠", u8"ang" },
    { u8"⦤", u8"ange" },
    { u8"∠", u8"angle" },
    { u8"∡", u8"angmsd" },
    { u8"⦨", u8"angmsdaa" },
    { u8"⦩", u8"angmsdab" },
    { u8"⦪", u8"angmsdac" },
    { u8"⦫", u8"angmsdad" },
    { u8"⦬", u8"angmsdae" },
    { u8"⦭", u8"angmsdaf" },
    { u8"⦮", u8"angmsdag" },
    { u8"⦯", u8"angmsdah" },
    { u8"∟", u8"angrt" },
    { u8"⊾", u8"angrtvb" },
    { u8"⦝", u8"angrtvbd" },
    { u8"∢", u8"angsph" },
    { u8"Å", u8"angst" },
    { u8"⍼", u8"angzarr" },
    { u8"Ą", u8"Aogon" },
    { u8"ą", u8"aogon" },
    { u8"𝔸", u8"Aopf" },
    { u8"𝕒", u8"aopf" },
    { u8"≈", u8"ap" },
    { u8"⩯", u8"apacir" },
    { u8"⩰", u8"apE" },
    { u8"≊", u8"ape" },
    { u8"≋", u8"apid" },
    { u8"'", u8"apos", false },
    { u8"⁡", u8"ApplyFunction" },
    { u8"≈", u8"approx" },
    { u8"≊", u8"approxeq" },
    { u8"Å", u8"Aring" },
    { u8"å", u8"aring" },
    { u8"𝒜", u8"Ascr" },
    { u8"𝒶", u8"ascr" },
    { u8"≔", u8"Assign" },
    { u8"*", u8"ast", false },
    { u8"≈", u8"asymp" },
    { u8"≍", u8"asympeq" },
    { u8"Ã", u8"Atilde" },
    { u8"ã", u8"atilde" },
    { u8"Ä", u8"Auml" },
    { u8"ä", u8"auml" },
    { u8"∳", u8"awconint" },
    { u8"⨑", u8"awint" },
    { u8"≌", u8"backcong" },
    { u8"϶", u8"backepsilon" },
    { u8"‵", u8"backprime" },
    { u8"∽", u8"backsim" },
    { u8"⋍", u8"backsimeq" },
    { u8"∖", u8"Backslash" },
    { u8"!", u8"bang", false },
    { u8"⫧", u8"Barv" },
    { u8"⊽", u8"barvee" },
    { u8"⌆", u8"Barwed" },
    { u8"⌅", u8"barwed" },
    { u8"⌅", u8"barwedge" },
    { u8"⎵", u8"bbrk" },
    { u8"⎶", u8"bbrktbrk" },
    { u8"≌", u8"bcong" },
    { u8"Б", u8"Bcy" },
    { u8"б", u8"bcy" },
    { u8"„", u8"bdquo" },
    { u8"∵", u8"becaus" },
    { u8"∵", u8"Because" },
    { u8"∵", u8"because" },
    { u8"⦰", u8"bemptyv" },
    { u8"϶", u8"bepsi" },
    { u8"ℬ", u8"bernou" },
    { u8"ℬ", u8"Bernoullis" },
    { u8"Β", u8"Beta" },
    { u8"β", u8"beta" },
    { u8"ℶ", u8"beth" },
    { u8"≬", u8"between" },
    { u8"𝔅", u8"Bfr" },
    { u8"𝔟", u8"bfr" },
    { u8"⋂", u8"bigcap" },
    { u8"◯", u8"bigcirc" },
    { u8"⋃", u8"bigcup" },
    { u8"⨀", u8"bigodot" },
    { u8"⨁", u8"bigoplus" },
    { u8"⨂", u8"bigotimes" },
    { u8"⨆", u8"bigsqcup" },
    { u8"★", u8"bigstar" },
    { u8"▽", u8"bigtriangledown" },
    { u8"△", u8"bigtriangleup" },
    { u8"⨄", u8"biguplus" },
    { u8"⋁", u8"bigvee" },
    { u8"⋀", u8"bigwedge" },
    { u8"⤍", u8"bkarow" },
    { u8"⧫", u8"blacklozenge" },
    { u8"▪", u8"blacksquare" },
    { u8"▴", u8"blacktriangle" },
    { u8"▾", u8"blacktriangledown" },
    { u8"◂", u8"blacktriangleleft" },
    { u8"▸", u8"blacktriangleright" },
    { u8"␣", u8"blank" },
    { u8"▒", u8"blk12" },
    { u8"░", u8"blk14" },
    { u8"▓", u8"blk34" },
    { u8"█", u8"block" },
    { u8"=⃥", u8"bne" },
    { u8"≡⃥", u8"bnequiv" },
    { u8"⫭", u8"bNot" },
    { u8"⌐", u8"bnot" },
    { u8"𝔹", u8"Bopf" },
    { u8"𝕓", u8"bopf" },
    { u8"⊥", u8"bot" },
    { u8"⊥", u8"bottom" },
    { u8"⋈", u8"bowtie" },
    { u8"⧉", u8"boxbox" },
    { u8"╗", u8"boxDL" },
    { u8"╖", u8"boxDl" },
    { u8"╕", u8"boxdL" },
    { u8"┐", u8"boxdl" },
    { u8"╔", u8"boxDR" },
    { u8"╓", u8"boxDr" },
    { u8"╒", u8"boxdR" },
    { u8"┌", u8"boxdr" },
    { u8"═", u8"boxH" },
    { u8"─", u8"boxh" },
    { u8"╦", u8"boxHD" },
    { u8"╤", u8"boxHd" },
    { u8"╥", u8"boxhD" },
    { u8"┬", u8"boxhd" },
    { u8"╩", u8"boxHU" },
    { u8"╧", u8"boxHu" },
    { u8"╨", u8"boxhU" },
    { u8"┴", u8"boxhu" },
    { u8"⊟", u8"boxminus" },
    { u8"⊞", u8"boxplus" },
    { u8"⊠", u8"boxtimes" },
    { u8"╝", u8"boxUL" },
    { u8"╜", u8"boxUl" },
    { u8"╛", u8"boxuL" },
    { u8"┘", u8"boxul" },
    { u8"╚", u8"boxUR" },
    { u8"╙", u8"boxUr" },
    { u8"╘", u8"boxuR" },
    { u8"└", u8"boxur" },
    { u8"║", u8"boxV" },
    { u8"│", u8"boxv" },
    { u8"╬", u8"boxVH" },
    { u8"╫", u8"boxVh" },
    { u8"╪", u8"boxvH" },
    { u8"┼", u8"boxvh" },
    { u8"╣", u8"boxVL" },
    { u8"╢", u8"boxVl" },
    { u8"╡", u8"boxvL" },
    { u8"┤", u8"boxvl" },
    { u8"╠", u8"boxVR" },
    { u8"╟", u8"boxVr" },
    { u8"╞", u8"boxvR" },
    { u8"├", u8"boxvr" },
    { u8"‵", u8"bprime" },
    { u8"˘", u8"Breve" },
    { u8"˘", u8"breve" },
    { u8"¦", u8"brvbar" },
    { u8"ℬ", u8"Bscr" },
    { u8"𝒷", u8"bscr" },
    { u8"⁏", u8"bsemi" },
    { u8"∽", u8"bsim" },
    { u8"⋍", u8"bsime" },
    { u8"\\", u8"bsol", false },
    { u8"⧅", u8"bsolb" },
    { u8"⟈", u8"bsolhsub" },
    { u8"•", u8"bull" },
    { u8"•", u8"bullet" },
    { u8"≎", u8"bump" },
    { u8"⪮", u8"bumpE" },
    { u8"≏", u8"bumpe" },
    { u8"≎", u8"Bumpeq" },
    { u8"≏", u8"bumpeq" },
    { u8"Ć", u8"Cacute" },
    { u8"ć", u8"cacute" },
    { u8"⋒", u8"Cap" },
    { u8"∩", u8"cap" },
    { u8"⩄", u8"capand" },
    { u8"⩉", u8"capbrcup" },
    { u8"⩋", u8"capcap" },
    { u8"⩇", u8"capcup" },
    { u8"⩀", u8"capdot" },
    { u8"ⅅ", u8"CapitalDifferentialD" },
    { u8"∩︀", u8"caps" },
    { u8"⁁", u8"caret" },
    { u8"ˇ", u8"caron" },
    { u8"ℭ", u8"Cayleys" },
    { u8"⩍", u8"ccaps" },
    { u8"Č", u8"Ccaron" },
    { u8"č", u8"ccaron" },
    { u8"Ç", u8"Ccedil" },
    { u8"ç", u8"ccedil" },
    { u8"Ĉ", u8"Ccirc" },
    { u8"ĉ", u8"ccirc" },
    { u8"∰", u8"Cconint" },
    { u8"⩌", u8"ccups" },
    { u8"⩐", u8"ccupssm" },
    { u8"Ċ", u8"Cdot" },
    { u8"ċ", u8"cdot" },
    { u8"¸", u8"cedil" },
    { u8"¸", u8"Cedilla" },
    { u8"⦲", u8"cemptyv" },
    { u8"¢", u8"cent" },
    { u8"·", u8"CenterDot" },
    { u8"·", u8"centerdot" },
    { u8"ℭ", u8"Cfr" },
    { u8"𝔠", u8"cfr" },
    { u8"Ч", u8"CHcy" },
    { u8"ч", u8"chcy" },
    { u8"✓", u8"check" },
    { u8"✓", u8"checkmark" },
    { u8"Χ", u8"Chi" },
    { u8"χ", u8"chi" },
    { u8"○", u8"cir" },
    { u8"ˆ", u8"circ" },
    { u8"≗", u8"circeq" },
    { u8"↺", u8"circlearrowleft" },
    { u8"↻", u8"circlearrowright" },
    { u8"⊛", u8"circledast" },
    { u8"⊚", u8"circledcirc" },
    { u8"⊝", u8"circleddash" },
    { u8"⊙", u8"CircleDot" },
    { u8"®", u8"circledR" },
    { u8"Ⓢ", u8"circledS" },
    { u8"⊖", u8"CircleMinus" },
    { u8"⊕", u8"CirclePlus" },
    { u8"⊗", u8"CircleTimes" },
    { u8"⧃", u8"cirE" },
    { u8"≗", u8"cire" },
    { u8"⨐", u8"cirfnint" },
    { u8"⫯", u8"cirmid" },
    { u8"⧂", u8"cirscir" },
    { u8"∲", u8"ClockwiseContourIntegral" },
    { u8"”", u8"CloseCurlyDoubleQuote" },
    { u8"’", u8"CloseCurlyQuote" },
    { u8"♣", u8"clubs" },
    { u8"♣", u8"clubsuit" },
    { u8"∷", u8"Colon" },
    { u8":", u8"colon", false },
    { u8"⩴", u8"Colone" },
    { u8"≔", u8"colone" },
    { u8"≔", u8"coloneq" },
    { u8",", u8"comma", false },
    { u8"@", u8"commat", false },
    { u8"∁", u8"comp" },
    { u8"∘", u8"compfn" },
    { u8"∁", u8"complement" },
    { u8"ℂ", u8"complexes" },
    { u8"≅", u8"cong" },
    { u8"⩭", u8"congdot" },
    { u8"≡", u8"Congruent" },
    { u8"∯", u8"Conint" },
    { u8"∮", u8"conint" },
    { u8"∮", u8"ContourIntegral" },
    { u8"ℂ", u8"Copf" },
    { u8"𝕔", u8"copf" },
    { u8"∐", u8"coprod" },
    { u8"∐", u8"Coproduct" },
    { u8"©", u8"copy" },
    { u8"©", u8"COPY" },
    { u8"℗", u8"copysr" },
    { u8"∳", u8"CounterClockwiseContourIntegral" },
    { u8"↵", u8"crarr" },
    { u8"⨯", u8"Cross" },
    { u8"✗", u8"cross" },
    { u8"𝒞", u8"Cscr" },
    { u8"𝒸", u8"cscr" },
    { u8"⫏", u8"csub" },
    { u8"⫑", u8"csube" },
    { u8"⫐", u8"csup" },
    { u8"⫒", u8"csupe" },
    { u8"⋯", u8"ctdot" },
    { u8"⤸", u8"cudarrl" },
    { u8"⤵", u8"cudarrr" },
    { u8"⋞", u8"cuepr" },
    { u8"⋟", u8"cuesc" },
    { u8"↶", u8"cularr" },
    { u8"⤽", u8"cularrp" },
    { u8"⋓", u8"Cup" },
    { u8"∪", u8"cup" },
    { u8"⩈", u8"cupbrcap" },
    { u8"≍", u8"CupCap" },
    { u8"⩆", u8"cupcap" },
    { u8"⩊", u8"cupcup" },
    { u8"⊍", u8"cupdot" },
    { u8"⩅", u8"cupor" },
    { u8"∪︀", u8"cups" },
    { u8"↷", u8"curarr" },
    { u8"⤼", u8"curarrm" },
    { u8"⋞", u8"curlyeqprec" },
    { u8"⋟", u8"curlyeqsucc" },
    { u8"⋎", u8"curlyvee" },
    { u8"⋏", u8"curlywedge" },
    { u8"¤", u8"curren" },
    { u8"↶", u8"curvearrowleft" },
    { u8"↷", u8"curvearrowright" },
    { u8"⋎", u8"cuvee" },
    { u8"⋏", u8"cuwed" },
    { u8"∲", u8"cwconint" },
    { u8"∱", u8"cwint" },
    { u8"⌭", u8"cylcty" },
    { u8"‡", u8"Dagger" },
    { u8"†", u8"dagger" },
    { u8"ℸ", u8"daleth" },
    { u8"↡", u8"Darr" },
    { u8"⇓", u8"dArr" },
    { u8"↓", u8"darr" },
    { u8"‐", u8"dash" },
    { u8"⫤", u8"Dashv" },
    { u8"⊣", u8"dashv" },
    { u8"⤏", u8"dbkarow" },
    { u8"˝", u8"dblac" },
    { u8"Ď", u8"Dcaron" },
    { u8"ď", u8"dcaron" },
    { u8"Д", u8"Dcy" },
    { u8"д", u8"dcy" },
    { u8"ⅅ", u8"DD" },
    { u8"ⅆ", u8"dd" },
    { u8"‡", u8"ddagger" },
    { u8"⇊", u8"ddarr" },
    { u8"⤑", u8"DDotrahd" },
    { u8"⩷", u8"ddotseq" },
    { u8"°", u8"deg" },
    { u8"∇", u8"Del" },
    { u8"Δ", u8"Delta" },
    { u8"δ", u8"delta" },
    { u8"⦱", u8"demptyv" },
    { u8"⥿", u8"dfisht" },
    { u8"𝔇", u8"Dfr" },
    { u8"𝔡", u8"dfr" },
    { u8"⥥", u8"dHar" },
    { u8"⇃", u8"dharl" },
    { u8"⇂", u8"dharr" },
    { u8"´", u8"DiacriticalAcute" },
    { u8"˙", u8"DiacriticalDot" },
    { u8"˝", u8"DiacriticalDoubleAcute" },
    { u8"`", u8"DiacriticalGrave" },
    { u8"˜", u8"DiacriticalTilde" },
    { u8"⋄", u8"diam" },
    { u8"⋄", u8"Diamond" },
    { u8"⋄", u8"diamond" },
    { u8"♦", u8"diamondsuit" },
    { u8"♦", u8"diams" },
    { u8"¨", u8"die" },
    { u8"ⅆ", u8"DifferentialD" },
    { u8"ϝ", u8"digamma" },
    { u8"⋲", u8"disin" },
    { u8"÷", u8"div" },
    { u8"÷", u8"divide" },
    { u8"⋇", u8"divideontimes" },
    { u8"⋇", u8"divonx" },
    { u8"Ђ", u8"DJcy" },
    { u8"ђ", u8"djcy" },
    { u8"⌞", u8"dlcorn" },
    { u8"⌍", u8"dlcrop" },
    { u8"$", u8"dollar", false },
    { u8"𝔻", u8"Dopf" },
    { u8"𝕕", u8"dopf" },
    { u8"¨", u8"Dot" },
    { u8"˙", u8"dot" },
    { u8"◌⃜", u8"DotDot" },
    { u8"≐", u8"doteq" },
    { u8"≑", u8"doteqdot" },
    { u8"≐", u8"DotEqual" },
    { u8"∸", u8"dotminus" },
    { u8"∔", u8"dotplus" },
    { u8"⊡", u8"dotsquare" },
    { u8"⌆", u8"doublebarwedge" },
    { u8"∯", u8"DoubleContourIntegral" },
    { u8"¨", u8"DoubleDot" },
    { u8"⇓", u8"DoubleDownArrow" },
    { u8"⇐", u8"DoubleLeftArrow" },
    { u8"⇔", u8"DoubleLeftRightArrow" },
    { u8"⫤", u8"DoubleLeftTee" },
    { u8"⟸", u8"DoubleLongLeftArrow" },
    { u8"⟺", u8"DoubleLongLeftRightArrow" },
    { u8"⟹", u8"DoubleLongRightArrow" },
    { u8"⇒", u8"DoubleRightArrow" },
    { u8"⊨", u8"DoubleRightTee" },
    { u8"⇑", u8"DoubleUpArrow" },
    { u8"⇕", u8"DoubleUpDownArrow" },
    { u8"∥", u8"DoubleVerticalBar" },
    { u8"↓", u8"DownArrow" },
    { u8"⇓", u8"Downarrow" },
    { u8"↓", u8"downarrow" },
    { u8"⤓", u8"DownArrowBar" },
    { u8"⇵", u8"DownArrowUpArrow" },
    { u8"◌̑", u8"DownBreve" },
    { u8"⇊", u8"downdownarrows" },
    { u8"⇃", u8"downharpoonleft" },
    { u8"⇂", u8"downharpoonright" },
    { u8"⥐", u8"DownLeftRightVector" },
    { u8"⥞", u8"DownLeftTeeVector" },
    { u8"↽", u8"DownLeftVector" },
    { u8"⥖", u8"DownLeftVectorBar" },
    { u8"⥟", u8"DownRightTeeVector" },
    { u8"⇁", u8"DownRightVector" },
    { u8"⥗", u8"DownRightVectorBar" },
    { u8"⊤", u8"DownTee" },
    { u8"↧", u8"DownTeeArrow" },
    { u8"⤐", u8"drbkarow" },
    { u8"⌟", u8"drcorn" },
    { u8"⌌", u8"drcrop" },
    { u8"𝒟", u8"Dscr" },
    { u8"𝒹", u8"dscr" },
    { u8"Ѕ", u8"DScy" },
    { u8"ѕ", u8"dscy" },
    { u8"⧶", u8"dsol" },
    { u8"Đ", u8"Dstrok" },
    { u8"đ", u8"dstrok" },
    { u8"⋱", u8"dtdot" },
    { u8"▿", u8"dtri" },
    { u8"▾", u8"dtrif" },
    { u8"⇵", u8"duarr" },
    { u8"⥯", u8"duhar" },
    { u8"⦦", u8"dwangle" },
    { u8"Џ", u8"DZcy" },
    { u8"џ", u8"dzcy" },
    { u8"⟿", u8"dzigrarr" },
    { u8"É", u8"Eacute" },
    { u8"é", u8"eacute" },
    { u8"⩮", u8"easter" },
    { u8"Ě", u8"Ecaron" },
    { u8"ě", u8"ecaron" },
    { u8"≖", u8"ecir" },
    { u8"Ê", u8"Ecirc" },
    { u8"ê", u8"ecirc" },
    { u8"≕", u8"ecolon" },
    { u8"Э", u8"Ecy" },
    { u8"э", u8"ecy" },
    { u8"⩷", u8"eDDot" },
    { u8"Ė", u8"Edot" },
    { u8"≑", u8"eDot" },
    { u8"ė", u8"edot" },
    { u8"ⅇ", u8"ee" },
    { u8"≒", u8"efDot" },
    { u8"𝔈", u8"Efr" },
    { u8"𝔢", u8"efr" },
    { u8"⪚", u8"eg" },
    { u8"È", u8"Egrave" },
    { u8"è", u8"egrave" },
    { u8"⪖", u8"egs" },
    { u8"⪘", u8"egsdot" },
    { u8"⪙", u8"el" },
    { u8"∈", u8"Element" },
    { u8"⏧", u8"elinters" },
    { u8"ℓ", u8"ell" },
    { u8"⪕", u8"els" },
    { u8"⪗", u8"elsdot" },
    { u8"Ē", u8"Emacr" },
    { u8"ē", u8"emacr" },
    { u8"∅", u8"empty" },
    { u8"∅", u8"emptyset" },
    { u8"◻", u8"EmptySmallSquare" },
    { u8"∅", u8"emptyv" },
    { u8"▫", u8"EmptyVerySmallSquare" },
    { u8" ", u8"emsp" },
    { u8" ", u8"emsp13" },
    { u8" ", u8"emsp14" },
    { u8"Ŋ", u8"ENG" },
    { u8"ŋ", u8"eng" },
    { u8" ", u8"ensp" },
    { u8"Ę", u8"Eogon" },
    { u8"ę", u8"eogon" },
    { u8"𝔼", u8"Eopf" },
    { u8"𝕖", u8"eopf" },
    { u8"⋕", u8"epar" },
    { u8"⧣", u8"eparsl" },
    { u8"⩱", u8"eplus" },
    { u8"ε", u8"epsi" },
    { u8"Ε", u8"Epsilon" },
    { u8"ε", u8"epsilon" },
    { u8"ϵ", u8"epsiv" },
    { u8"≖", u8"eqcirc" },
    { u8"≕", u8"eqcolon" },
    { u8"≂", u8"eqsim" },
    { u8"⪖", u8"eqslantgtr" },
    { u8"⪕", u8"eqslantless" },
    { u8"⩵", u8"Equal" },
    { u8"=", u8"equals", false },
    { u8"≂", u8"EqualTilde" },
    { u8"≟", u8"equest" },
    { u8"⇌", u8"Equilibrium" },
    { u8"≡", u8"equiv" },
    { u8"⩸", u8"equivDD" },
    { u8"⧥", u8"eqvparsl" },
    { u8"⥱", u8"erarr" },
    { u8"≓", u8"erDot" },
    { u8"ℰ", u8"Escr" },
    { u8"ℯ", u8"escr" },
    { u8"≐", u8"esdot" },
    { u8"⩳", u8"Esim" },
    { u8"≂", u8"esim" },
    { u8"Η", u8"Eta" },
    { u8"η", u8"eta" },
    { u8"Ð", u8"ETH" },
    { u8"ð", u8"eth" },
    { u8"Ë", u8"Euml" },
    { u8"ë", u8"euml" },
    { u8"€", u8"euro" },
    { u8"!", u8"excl", false },
    { u8"∃", u8"exist" },
    { u8"∃", u8"Exists" },
    { u8"ℰ", u8"expectation" },
    { u8"ⅇ", u8"ExponentialE" },
    { u8"ⅇ", u8"exponentiale" },
    { u8"≒", u8"fallingdotseq" },
    { u8"Ф", u8"Fcy" },
    { u8"ф", u8"fcy" },
    { u8"♀", u8"female" },
    { u8"ﬃ", u8"ffilig" },
    { u8"ﬀ", u8"fflig" },
    { u8"ﬄ", u8"ffllig" },
    { u8"𝔉", u8"Ffr" },
    { u8"𝔣", u8"ffr" },
    { u8"ﬁ", u8"filig" },
    { u8"◼", u8"FilledSmallSquare" },
    { u8"▪", u8"FilledVerySmallSquare" },
    { u8"fj", u8"fjlig" },
    { u8"♭", u8"flat" },
    { u8"ﬂ", u8"fllig" },
    { u8"▱", u8"fltns" },
    { u8"ƒ", u8"fnof" },
    { u8"𝔽", u8"Fopf" },
    { u8"𝕗", u8"fopf" },
    { u8"∀", u8"ForAll" },
    { u8"∀", u8"forall" },
    { u8"⋔", u8"fork" },
    { u8"⫙", u8"forkv" },
    { u8"ℱ", u8"Fouriertrf" },
    { u8"⨍", u8"fpartint" },
    { u8"½", u8"frac12" },
    { u8"⅓", u8"frac13" },
    { u8"¼", u8"frac14" },
    { u8"⅕", u8"frac15" },
    { u8"⅙", u8"frac16" },
    { u8"⅛", u8"frac18" },
    { u8"⅔", u8"frac23" },
    { u8"⅖", u8"frac25" },
    { u8"¾", u8"frac34" },
    { u8"⅗", u8"frac35" },
    { u8"⅜", u8"frac38" },
    { u8"⅘", u8"frac45" },
    { u8"⅚", u8"frac56" },
    { u8"⅝", u8"frac58" },
    { u8"⅞", u8"frac78" },
    { u8"⁄", u8"frasl" },
    { u8"⌢", u8"frown" },
    { u8"ℱ", u8"Fscr" },
    { u8"𝒻", u8"fscr" },
    { u8"ǵ", u8"gacute" },
    { u8"Γ", u8"Gamma" },
    { u8"γ", u8"gamma" },
    { u8"Ϝ", u8"Gammad" },
    { u8"ϝ", u8"gammad" },
    { u8"⪆", u8"gap" },
    { u8"Ğ", u8"Gbreve" },
    { u8"ğ", u8"gbreve" },
    { u8"Ģ", u8"Gcedil" },
    { u8"Ĝ", u8"Gcirc" },
    { u8"ĝ", u8"gcirc" },
    { u8"Г", u8"Gcy" },
    { u8"г", u8"gcy" },
    { u8"Ġ", u8"Gdot" },
    { u8"ġ", u8"gdot" },
    { u8"≧", u8"gE" },
    { u8"≥", u8"ge" },
    { u8"⪌", u8"gEl" },
    { u8"⋛", u8"gel" },
    { u8"≥", u8"geq" },
    { u8"≧", u8"geqq" },
    { u8"⩾", u8"geqslant" },
    { u8"⩾", u8"ges" },
    { u8"⪩", u8"gescc" },
    { u8"⪀", u8"gesdot" },
    { u8"⪂", u8"gesdoto" },
    { u8"⪄", u8"gesdotol" },
    { u8"⋛︀", u8"gesl" },
    { u8"⪔", u8"gesles" },
    { u8"𝔊", u8"Gfr" },
    { u8"𝔤", u8"gfr" },
    { u8"⋙", u8"Gg" },
    { u8"≫", u8"gg" },
    { u8"⋙", u8"ggg" },
    { u8"ℷ", u8"gimel" },
    { u8"Ѓ", u8"GJcy" },
    { u8"ѓ", u8"gjcy" },
    { u8"≷", u8"gl" },
    { u8"⪥", u8"gla" },
    { u8"⪒", u8"glE" },
    { u8"⪤", u8"glj" },
    { u8"⪊", u8"gnap" },
    { u8"⪊", u8"gnapprox" },
    { u8"≩", u8"gnE" },
    { u8"⪈", u8"gne" },
    { u8"⪈", u8"gneq" },
    { u8"≩", u8"gneqq" },
    { u8"⋧", u8"gnsim" },
    { u8"𝔾", u8"Gopf" },
    { u8"𝕘", u8"gopf" },
    { u8"`", u8"grave" },
    { u8"≥", u8"GreaterEqual" },
    { u8"⋛", u8"GreaterEqualLess" },
    { u8"≧", u8"GreaterFullEqual" },
    { u8"⪢", u8"GreaterGreater" },
    { u8"≷", u8"GreaterLess" },
    { u8"⩾", u8"GreaterSlantEqual" },
    { u8"≳", u8"GreaterTilde" },
    { u8"𝒢", u8"Gscr" },
    { u8"ℊ", u8"gscr" },
    { u8"≳", u8"gsim" },
    { u8"⪎", u8"gsime" },
    { u8"⪐", u8"gsiml" },
    { u8">", u8"gt" },
    { u8">", u8"GT" },
    { u8"≫", u8"Gt" },
    { u8"⪧", u8"gtcc" },
    { u8"⩺", u8"gtcir" },
    { u8"⋗", u8"gtdot" },
    { u8"⦕", u8"gtlPar" },
    { u8"⩼", u8"gtquest" },
    { u8"⪆", u8"gtrapprox" },
    { u8"⥸", u8"gtrarr" },
    { u8"⋗", u8"gtrdot" },
    { u8"⋛", u8"gtreqless" },
    { u8"⪌", u8"gtreqqless" },
    { u8"≷", u8"gtrless" },
    { u8"≳", u8"gtrsim" },
    { u8"≩︀", u8"gvertneqq" },
    { u8"≩︀", u8"gvnE" },
    { u8"ˇ", u8"Hacek" },
    { u8" ", u8"hairsp" },
    { u8"½", u8"half" },
    { u8"ℋ", u8"hamilt" },
    { u8"Ъ", u8"HARDcy" },
    { u8"ъ", u8"hardcy" },
    { u8"⇔", u8"hArr" },
    { u8"↔", u8"harr" },
    { u8"⥈", u8"harrcir" },
    { u8"↭", u8"harrw" },
    { u8"#", u8"hash", false },
    { u8"^", u8"Hat", false },
    { u8"ℏ", u8"hbar" },
    { u8"Ĥ", u8"Hcirc" },
    { u8"ĥ", u8"hcirc" },
    { u8"♥", u8"hearts" },
    { u8"♥", u8"heartsuit" },
    { u8"…", u8"hellip" },
    { u8"⊹", u8"hercon" },
    { u8"ℌ", u8"Hfr" },
    { u8"𝔥", u8"hfr" },
    { u8"ℋ", u8"HilbertSpace" },
    { u8"⤥", u8"hksearow" },
    { u8"⤦", u8"hkswarow" },
    { u8"⇿", u8"hoarr" },
    { u8"∻", u8"homtht" },
    { u8"↩", u8"hookleftarrow" },
    { u8"↪", u8"hookrightarrow" },
    { u8"ℍ", u8"Hopf" },
    { u8"𝕙", u8"hopf" },
    { u8"―", u8"horbar" },
    { u8"─", u8"HorizontalLine" },
    { u8"ℋ", u8"Hscr" },
    { u8"𝒽", u8"hscr" },
    { u8"ℏ", u8"hslash" },
    { u8"Ħ", u8"Hstrok" },
    { u8"ħ", u8"hstrok" },
    { u8"≎", u8"HumpDownHump" },
    { u8"≏", u8"HumpEqual" },
    { u8"⁃", u8"hybull" },
    { u8"‐", u8"hyphen" },
    { u8"Í", u8"Iacute" },
    { u8"í", u8"iacute" },
    { u8"⁣", u8"ic" },
    { u8"Î", u8"Icirc" },
    { u8"î", u8"icirc" },
    { u8"И", u8"Icy" },
    { u8"и", u8"icy" },
    { u8"İ", u8"Idot" },
    { u8"Е", u8"IEcy" },
    { u8"е", u8"iecy" },
    { u8"¡", u8"iexcl" },
    { u8"⇔", u8"iff" },
    { u8"ℑ", u8"Ifr" },
    { u8"𝔦", u8"ifr" },
    { u8"Ì", u8"Igrave" },
    { u8"ì", u8"igrave" },
    { u8"ⅈ", u8"ii" },
    { u8"⨌", u8"iiiint" },
    { u8"∭", u8"iiint" },
    { u8"⧜", u8"iinfin" },
    { u8"℩", u8"iiota" },
    { u8"Ĳ", u8"IJlig" },
    { u8"ĳ", u8"ijlig" },
    { u8"ℑ", u8"Im" },
    { u8"Ī", u8"Imacr" },
    { u8"ī", u8"imacr" },
    { u8"ℑ", u8"image" },
    { u8"ⅈ", u8"ImaginaryI" },
    { u8"ℐ", u8"imagline" },
    { u8"ℑ", u8"imagpart" },
    { u8"ı", u8"imath" },
    { u8"⊷", u8"imof" },
    { u8"Ƶ", u8"imped" },
    { u8"⇒", u8"Implies" },
    { u8"∈", u8"in" },
    { u8"℅", u8"incare" },
    { u8"∞", u8"infin" },
    { u8"⧝", u8"infintie" },
    { u8"ı", u8"inodot" },
    { u8"∬", u8"Int" },
    { u8"∫", u8"int" },
    { u8"⊺", u8"intcal" },
    { u8"ℤ", u8"integers" },
    { u8"∫", u8"Integral" },
    { u8"⊺", u8"intercal" },
    { u8"⋂", u8"Intersection" },
    { u8"⨗", u8"intlarhk" },
    { u8"⨼", u8"intprod" },
    { u8"⁣", u8"InvisibleComma" },
    { u8"⁢", u8"InvisibleTimes" },
    { u8"Ё", u8"IOcy" },
    { u8"ё", u8"iocy" },
    { u8"Į", u8"Iogon" },
    { u8"į", u8"iogon" },
    { u8"𝕀", u8"Iopf" },
    { u8"𝕚", u8"iopf" },
    { u8"Ι", u8"Iota" },
    { u8"ι", u8"iota" },
    { u8"⨼", u8"iprod" },
    { u8"¿", u8"iquest" },
    { u8"ℐ", u8"Iscr" },
    { u8"𝒾", u8"iscr" },
    { u8"∈", u8"isin" },
    { u8"⋵", u8"isindot" },
    { u8"⋹", u8"isinE" },
    { u8"⋴", u8"isins" },
    { u8"⋳", u8"isinsv" },
    { u8"∈", u8"isinv" },
    { u8"⁢", u8"it" },
    { u8"Ĩ", u8"Itilde" },
    { u8"ĩ", u8"itilde" },
    { u8"І", u8"Iukcy" },
    { u8"і", u8"iukcy" },
    { u8"Ï", u8"Iuml" },
    { u8"ï", u8"iuml" },
    { u8"Ĵ", u8"Jcirc" },
    { u8"ĵ", u8"jcirc" },
    { u8"Й", u8"Jcy" },
    { u8"й", u8"jcy" },
    { u8"𝔍", u8"Jfr" },
    { u8"𝔧", u8"jfr" },
    { u8"ȷ", u8"jmath" },
    { u8"𝕁", u8"Jopf" },
    { u8"𝕛", u8"jopf" },
    { u8"𝒥", u8"Jscr" },
    { u8"𝒿", u8"jscr" },
    { u8"Ј", u8"Jsercy" },
    { u8"ј", u8"jsercy" },
    { u8"Є", u8"Jukcy" },
    { u8"є", u8"jukcy" },
    { u8"Κ", u8"Kappa" },
    { u8"κ", u8"kappa" },
    { u8"ϰ", u8"kappav" },
    { u8"Ķ", u8"Kcedil" },
    { u8"ķ", u8"kcedil" },
    { u8"К", u8"Kcy" },
    { u8"к", u8"kcy" },
    { u8"𝔎", u8"Kfr" },
    { u8"𝔨", u8"kfr" },
    { u8"ĸ", u8"kgreen" },
    { u8"Х", u8"KHcy" },
    { u8"х", u8"khcy" },
    { u8"Ќ", u8"KJcy" },
    { u8"ќ", u8"kjcy" },
    { u8"𝕂", u8"Kopf" },
    { u8"𝕜", u8"kopf" },
    { u8"𝒦", u8"Kscr" },
    { u8"𝓀", u8"kscr" },
    { u8"⇚", u8"lAarr" },
    { u8"Ĺ", u8"Lacute" },
    { u8"ĺ", u8"lacute" },
    { u8"⦴", u8"laemptyv" },
    { u8"ℒ", u8"lagran" },
    { u8"Λ", u8"Lambda" },
    { u8"λ", u8"lambda" },
    { u8"⟪", u8"Lang" },
    { u8"⟨", u8"lang" },
    { u8"⦑", u8"langd" },
    { u8"⟨", u8"langle" },
    { u8"⪅", u8"lap" },
    { u8"ℒ", u8"Laplacetrf" },
    { u8"«", u8"laquo" },
    { u8"↞", u8"Larr" },
    { u8"⇐", u8"lArr" },
    { u8"←", u8"larr" },
    { u8"⇤", u8"larrb" },
    { u8"⤟", u8"larrbfs" },
    { u8"⤝", u8"larrfs" },
    { u8"↩", u8"larrhk" },
    { u8"↫", u8"larrlp" },
    { u8"⤹", u8"larrpl" },
    { u8"⥳", u8"larrsim" },
    { u8"↢", u8"larrtl" },
    { u8"⪫", u8"lat" },
    { u8"⤛", u8"lAtail" },
    { u8"⤙", u8"latail" },
    { u8"⪭", u8"late" },
    { u8"⪭︀", u8"lates" },
    { u8"⤎", u8"lBarr" },
    { u8"⤌", u8"lbarr" },
    { u8"❲", u8"lbbrk" },
    { u8"{", u8"lbrace", false },
    { u8"[", u8"lbrack", false },
    { u8"⦋", u8"lbrke" },
    { u8"⦏", u8"lbrksld" },
    { u8"⦍", u8"lbrkslu" },
    { u8"Ľ", u8"Lcaron" },
    { u8"ľ", u8"lcaron" },
    { u8"Ļ", u8"Lcedil" },
    { u8"ļ", u8"lcedil" },
    { u8"⌈", u8"lceil" },
    { u8"{", u8"lcub", false },
    { u8"Л", u8"Lcy" },
    { u8"л", u8"lcy" },
    { u8"⤶", u8"ldca" },
    { u8"“", u8"ldquo" },
    { u8"„", u8"ldquor" },
    { u8"⥧", u8"ldrdhar" },
    { u8"⥋", u8"ldrushar" },
    { u8"↲", u8"ldsh" },
    { u8"≦", u8"lE" },
    { u8"≤", u8"le" },
    { u8"⟨", u8"LeftAngleBracket" },
    { u8"←", u8"LeftArrow" },
    { u8"⇐", u8"Leftarrow" },
    { u8"←", u8"leftarrow" },
    { u8"⇤", u8"LeftArrowBar" },
    { u8"⇆", u8"LeftArrowRightArrow" },
    { u8"↢", u8"leftarrowtail" },
    { u8"⌈", u8"LeftCeiling" },
    { u8"⟦", u8"LeftDoubleBracket" },
    { u8"⥡", u8"LeftDownTeeVector" },
    { u8"⇃", u8"LeftDownVector" },
    { u8"⥙", u8"LeftDownVectorBar" },
    { u8"⌊", u8"LeftFloor" },
    { u8"↽", u8"leftharpoondown" },
    { u8"↼", u8"leftharpoonup" },
    { u8"⇇", u8"leftleftarrows" },
    { u8"↔", u8"LeftRightArrow" },
    { u8"⇔", u8"Leftrightarrow" },
    { u8"↔", u8"leftrightarrow" },
    { u8"⇆", u8"leftrightarrows" },
    { u8"⇋", u8"leftrightharpoons" },
    { u8"↭", u8"leftrightsquigarrow" },
    { u8"⥎", u8"LeftRightVector" },
    { u8"⊣", u8"LeftTee" },
    { u8"↤", u8"LeftTeeArrow" },
    { u8"⥚", u8"LeftTeeVector" },
    { u8"⋋", u8"leftthreetimes" },
    { u8"⊲", u8"LeftTriangle" },
    { u8"⧏", u8"LeftTriangleBar" },
    { u8"⊴", u8"LeftTriangleEqual" },
    { u8"⥑", u8"LeftUpDownVector" },
    { u8"⥠", u8"LeftUpTeeVector" },
    { u8"↿", u8"LeftUpVector" },
    { u8"⥘", u8"LeftUpVectorBar" },
    { u8"↼", u8"LeftVector" },
    { u8"⥒", u8"LeftVectorBar" },
    { u8"⪋", u8"lEg" },
    { u8"⋚", u8"leg" },
    { u8"≤", u8"leq" },
    { u8"≦", u8"leqq" },
    { u8"⩽", u8"leqslant" },
    { u8"⩽", u8"les" },
    { u8"⪨", u8"lescc" },
    { u8"⩿", u8"lesdot" },
    { u8"⪁", u8"lesdoto" },
    { u8"⪃", u8"lesdotor" },
    { u8"⋚︀", u8"lesg" },
    { u8"⪓", u8"lesges" },
    { u8"⪅", u8"lessapprox" },
    { u8"⋖", u8"lessdot" },
    { u8"⋚", u8"lesseqgtr" },
    { u8"⪋", u8"lesseqqgtr" },
    { u8"⋚", u8"LessEqualGreater" },
    { u8"≦", u8"LessFullEqual" },
    { u8"≶", u8"LessGreater" },
    { u8"≶", u8"lessgtr" },
    { u8"⪡", u8"LessLess" },
    { u8"≲", u8"lesssim" },
    { u8"⩽", u8"LessSlantEqual" },
    { u8"≲", u8"LessTilde" },
    { u8"⥼", u8"lfisht" },
    { u8"⌊", u8"lfloor" },
    { u8"𝔏", u8"Lfr" },
    { u8"𝔩", u8"lfr" },
    { u8"≶", u8"lg" },
    { u8"⪑", u8"lgE" },
    { u8"⥢", u8"lHar" },
    { u8"↽", u8"lhard" },
    { u8"↼", u8"lharu" },
    { u8"⥪", u8"lharul" },
    { u8"▄", u8"lhblk" },
    { u8"Љ", u8"LJcy" },
    { u8"љ", u8"ljcy" },
    { u8"⋘", u8"Ll" },
    { u8"≪", u8"ll" },
    { u8"⇇", u8"llarr" },
    { u8"⌞", u8"llcorner" },
    { u8"⇚", u8"Lleftarrow" },
    { u8"⥫", u8"llhard" },
    { u8"◺", u8"lltri" },
    { u8"Ŀ", u8"Lmidot" },
    { u8"ŀ", u8"lmidot" },
    { u8"⎰", u8"lmoust" },
    { u8"⎰", u8"lmoustache" },
    { u8"⪉", u8"lnap" },
    { u8"⪉", u8"lnapprox" },
    { u8"≨", u8"lnE" },
    { u8"⪇", u8"lne" },
    { u8"⪇", u8"lneq" },
    { u8"≨", u8"lneqq" },
    { u8"⋦", u8"lnsim" },
    { u8"⟬", u8"loang" },
    { u8"⇽", u8"loarr" },
    { u8"⟦", u8"lobrk" },
    { u8"⟵", u8"LongLeftArrow" },
    { u8"⟸", u8"Longleftarrow" },
    { u8"⟵", u8"longleftarrow" },
    { u8"⟷", u8"LongLeftRightArrow" },
    { u8"⟺", u8"Longleftrightarrow" },
    { u8"⟷", u8"longleftrightarrow" },
    { u8"⟼", u8"longmapsto" },
    { u8"⟶", u8"LongRightArrow" },
    { u8"⟹", u8"Longrightarrow" },
    { u8"⟶", u8"longrightarrow" },
    { u8"↫", u8"looparrowleft" },
    { u8"↬", u8"looparrowright" },
    { u8"⦅", u8"lopar" },
    { u8"𝕃", u8"Lopf" },
    { u8"𝕝", u8"lopf" },
    { u8"⨭", u8"loplus" },
    { u8"⨴", u8"lotimes" },
    { u8"∗", u8"lowast" },
    { u8"_", u8"lowbar", false },
    { u8"↙", u8"LowerLeftArrow" },
    { u8"↘", u8"LowerRightArrow" },
    { u8"◊", u8"loz" },
    { u8"◊", u8"lozenge" },
    { u8"⧫", u8"lozf" },
    { u8"(", u8"lpar", false },
    { u8"⦓", u8"lparlt" },
    { u8"⇆", u8"lrarr" },
    { u8"⌟", u8"lrcorner" },
    { u8"⇋", u8"lrhar" },
    { u8"⥭", u8"lrhard" },
    { u8"‎", u8"lrm" },
    { u8"⊿", u8"lrtri" },
    { u8"‹", u8"lsaquo" },
    { u8"ℒ", u8"Lscr" },
    { u8"𝓁", u8"lscr" },
    { u8"↰", u8"Lsh" },
    { u8"↰", u8"lsh" },
    { u8"≲", u8"lsim" },
    { u8"⪍", u8"lsime" },
    { u8"⪏", u8"lsimg" },
    { u8"[", u8"lsqb", false },
    { u8"‘", u8"lsquo" },
    { u8"‚", u8"lsquor" },
    { u8"Ł", u8"Lstrok" },
    { u8"ł", u8"lstrok" },
    { u8"<", u8"lt" },
    { u8"<", u8"LT" },
    { u8"≪", u8"Lt" },
    { u8"⪦", u8"ltcc" },
    { u8"⩹", u8"ltcir" },
    { u8"⋖", u8"ltdot" },
    { u8"⋋", u8"lthree" },
    { u8"⋉", u8"ltimes" },
    { u8"⥶", u8"ltlarr" },
    { u8"⩻", u8"ltquest" },
    { u8"◃", u8"ltri" },
    { u8"⊴", u8"ltrie" },
    { u8"◂", u8"ltrif" },
    { u8"⦖", u8"ltrPar" },
    { u8"⥊", u8"lurdshar" },
    { u8"⥦", u8"luruhar" },
    { u8"≨︀", u8"lvertneqq" },
    { u8"≨︀", u8"lvnE" },
    { u8"¯", u8"macr" },
    { u8"♂", u8"male" },
    { u8"✠", u8"malt" },
    { u8"✠", u8"maltese" },
    { u8"⤅", u8"Map" },
    { u8"↦", u8"map" },
    { u8"↦", u8"mapsto" },
    { u8"↧", u8"mapstodown" },
    { u8"↤", u8"mapstoleft" },
    { u8"↥", u8"mapstoup" },
    { u8"▮", u8"marker" },
    { u8"⨩", u8"mcomma" },
    { u8"М", u8"Mcy" },
    { u8"м", u8"mcy" },
    { u8"—", u8"mdash" },
    { u8"∺", u8"mDDot" },
    { u8"∡", u8"measuredangle" },
    { u8" ", u8"MediumSpace" },
    { u8"ℳ", u8"Mellintrf" },
    { u8"𝔐", u8"Mfr" },
    { u8"𝔪", u8"mfr" },
    { u8"℧", u8"mho" },
    { u8"µ", u8"micro" },
    { u8"∣", u8"mid" },
    { u8"*", u8"midast", false },
    { u8"⫰", u8"midcir" },
    { u8"·", u8"middot" },
    { u8"−", u8"minus" },
    { u8"⊟", u8"minusb" },
    { u8"∸", u8"minusd" },
    { u8"⨪", u8"minusdu" },
    { u8"∓", u8"MinusPlus" },
    { u8"⫛", u8"mlcp" },
    { u8"…", u8"mldr" },
    { u8"∓", u8"mnplus" },
    { u8"⊧", u8"models" },
    { u8"𝕄", u8"Mopf" },
    { u8"𝕞", u8"mopf" },
    { u8"∓", u8"mp" },
    { u8"ℳ", u8"Mscr" },
    { u8"𝓂", u8"mscr" },
    { u8"∾", u8"mstpos" },
    { u8"Μ", u8"Mu" },
    { u8"μ", u8"mu" },
    { u8"⊸", u8"multimap" },
    { u8"⊸", u8"mumap" },
    { u8"∇", u8"nabla" },
    { u8"Ń", u8"Nacute" },
    { u8"ń", u8"nacute" },
    { u8"∠⃒", u8"nang" },
    { u8"≉", u8"nap" },
    { u8"⩰̸", u8"napE" },
    { u8"≋̸", u8"napid" },
    { u8"ŉ", u8"napos" },
    { u8"≉", u8"napprox" },
    { u8"♮", u8"natur" },
    { u8"♮", u8"natural" },
    { u8"ℕ", u8"naturals" },
    { u8" ", u8"nbsp", false },
    { u8"≎̸", u8"nbump" },
    { u8"≏̸", u8"nbumpe" },
    { u8"⩃", u8"ncap" },
    { u8"Ň", u8"Ncaron" },
    { u8"ň", u8"ncaron" },
    { u8"Ņ", u8"Ncedil" },
    { u8"ņ", u8"ncedil" },
    { u8"≇", u8"ncong" },
    { u8"⩭̸", u8"ncongdot" },
    { u8"⩂", u8"ncup" },
    { u8"Н", u8"Ncy" },
    { u8"н", u8"ncy" },
    { u8"–", u8"ndash" },
    { u8"≠", u8"ne" },
    { u8"⤤", u8"nearhk" },
    { u8"⇗", u8"neArr" },
    { u8"↗", u8"nearr" },
    { u8"↗", u8"nearrow" },
    { u8"≐̸", u8"nedot" },
    { u8"​", u8"NegativeMediumSpace" },
    { u8"​", u8"NegativeThickSpace" },
    { u8"​", u8"NegativeThinSpace" },
    { u8"​", u8"NegativeVeryThinSpace" },
    { u8"≢", u8"nequiv" },
    { u8"⤨", u8"nesear" },
    { u8"≂̸", u8"nesim" },
    { u8"≫", u8"NestedGreaterGreater" },
    { u8"≪", u8"NestedLessLess" },
    { u8"␊", u8"NewLine" },
    { u8"∄", u8"nexist" },
    { u8"∄", u8"nexists" },
    { u8"𝔑", u8"Nfr" },
    { u8"𝔫", u8"nfr" },
    { u8"≧̸", u8"ngE" },
    { u8"≱", u8"nge" },
    { u8"≱", u8"ngeq" },
    { u8"≧̸", u8"ngeqq" },
    { u8"⩾̸", u8"ngeqslant" },
    { u8"⩾̸", u8"nges" },
    { u8"⋙̸", u8"nGg" },
    { u8"≵", u8"ngsim" },
    { u8"≫⃒", u8"nGt" },
    { u8"≯", u8"ngt" },
    { u8"≯", u8"ngtr" },
    { u8"≫̸", u8"nGtv" },
    { u8"⇎", u8"nhArr" },
    { u8"↮", u8"nharr" },
    { u8"⫲", u8"nhpar" },
    { u8"∋", u8"ni" },
    { u8"⋼", u8"nis" },
    { u8"⋺", u8"nisd" },
    { u8"∋", u8"niv" },
    { u8"Њ", u8"NJcy" },
    { u8"њ", u8"njcy" },
    { u8"⇍", u8"nlArr" },
    { u8"↚", u8"nlarr" },
    { u8"‥", u8"nldr" },
    { u8"≦̸", u8"nlE" },
    { u8"≰", u8"nle" },
    { u8"⇍", u8"nLeftarrow" },
    { u8"↚", u8"nleftarrow" },
    { u8"⇎", u8"nLeftrightarrow" },
    { u8"↮", u8"nleftrightarrow" },
    { u8"≰", u8"nleq" },
    { u8"≦̸", u8"nleqq" },
    { u8"⩽̸", u8"nleqslant" },
    { u8"⩽̸", u8"nles" },
    { u8"≮", u8"nless" },
    { u8"⋘̸", u8"nLl" },
    { u8"≴", u8"nlsim" },
    { u8"≪⃒", u8"nLt" },
    { u8"≮", u8"nlt" },
    { u8"⋪", u8"nltri" },
    { u8"⋬", u8"nltrie" },
    { u8"≪̸", u8"nLtv" },
    { u8"∤", u8"nmid" },
    { u8"⁠", u8"NoBreak" },
    { u8" ", u8"NonBreakingSpace", false },
    { u8"ℕ", u8"Nopf" },
    { u8"𝕟", u8"nopf" },
    { u8"⫬", u8"Not" },
    { u8"¬", u8"not" },
    { u8"≢", u8"NotCongruent" },
    { u8"≭", u8"NotCupCap" },
    { u8"∦", u8"NotDoubleVerticalBar" },
    { u8"∉", u8"NotElement" },
    { u8"≠", u8"NotEqual" },
    { u8"≂̸", u8"NotEqualTilde" },
    { u8"∄", u8"NotExists" },
    { u8"≯", u8"NotGreater" },
    { u8"≱", u8"NotGreaterEqual" },
    { u8"≧̸", u8"NotGreaterFullEqual" },
    { u8"≫̸", u8"NotGreaterGreater" },
    { u8"≹", u8"NotGreaterLess" },
    { u8"⩾̸", u8"NotGreaterSlantEqual" },
    { u8"≵", u8"NotGreaterTilde" },
    { u8"≎̸", u8"NotHumpDownHump" },
    { u8"≏̸", u8"NotHumpEqual" },
    { u8"∉", u8"notin" },
    { u8"⋵̸", u8"notindot" },
    { u8"⋹̸", u8"notinE" },
    { u8"∉", u8"notinva" },
    { u8"⋷", u8"notinvb" },
    { u8"⋶", u8"notinvc" },
    { u8"⋪", u8"NotLeftTriangle" },
    { u8"⧏̸", u8"NotLeftTriangleBar" },
    { u8"⋬", u8"NotLeftTriangleEqual" },
    { u8"≮", u8"NotLess" },
    { u8"≰", u8"NotLessEqual" },
    { u8"≸", u8"NotLessGreater" },
    { u8"≪̸", u8"NotLessLess" },
    { u8"⩽̸", u8"NotLessSlantEqual" },
    { u8"≴", u8"NotLessTilde" },
    { u8"⪢̸", u8"NotNestedGreaterGreater" },
    { u8"⪡̸", u8"NotNestedLessLess" },
    { u8"∌", u8"notni" },
    { u8"∌", u8"notniva" },
    { u8"⋾", u8"notnivb" },
    { u8"⋽", u8"notnivc" },
    { u8"⊀", u8"NotPrecedes" },
    { u8"⪯̸", u8"NotPrecedesEqual" },
    { u8"⋠", u8"NotPrecedesSlantEqual" },
    { u8"∌", u8"NotReverseElement" },
    { u8"⋫", u8"NotRightTriangle" },
    { u8"⧐̸", u8"NotRightTriangleBar" },
    { u8"⋭", u8"NotRightTriangleEqual" },
    { u8"⊏̸", u8"NotSquareSubset" },
    { u8"⋢", u8"NotSquareSubsetEqual" },
    { u8"⊐̸", u8"NotSquareSuperset" },
    { u8"⋣", u8"NotSquareSupersetEqual" },
    { u8"⊂⃒", u8"NotSubset" },
    { u8"⊈", u8"NotSubsetEqual" },
    { u8"⊁", u8"NotSucceeds" },
    { u8"⪰̸", u8"NotSucceedsEqual" },
    { u8"⋡", u8"NotSucceedsSlantEqual" },
    { u8"≿̸", u8"NotSucceedsTilde" },
    { u8"⊃⃒", u8"NotSuperset" },
    { u8"⊉", u8"NotSupersetEqual" },
    { u8"≁", u8"NotTilde" },
    { u8"≄", u8"NotTildeEqual" },
    { u8"≇", u8"NotTildeFullEqual" },
    { u8"≉", u8"NotTildeTilde" },
    { u8"∤", u8"NotVerticalBar" },
    { u8"∦", u8"npar" },
    { u8"∦", u8"nparallel" },
    { u8"⫽⃥", u8"nparsl" },
    { u8"∂̸", u8"npart" },
    { u8"⨔", u8"npolint" },
    { u8"⊀", u8"npr" },
    { u8"⋠", u8"nprcue" },
    { u8"⪯̸", u8"npre" },
    { u8"⊀", u8"nprec" },
    { u8"⪯̸", u8"npreceq" },
    { u8"⇏", u8"nrArr" },
    { u8"↛", u8"nrarr" },
    { u8"⤳̸", u8"nrarrc" },
    { u8"↝̸", u8"nrarrw" },
    { u8"⇏", u8"nRightarrow" },
    { u8"↛", u8"nrightarrow" },
    { u8"⋫", u8"nrtri" },
    { u8"⋭", u8"nrtrie" },
    { u8"⊁", u8"nsc" },
    { u8"⋡", u8"nsccue" },
    { u8"⪰̸", u8"nsce" },
    { u8"𝒩", u8"Nscr" },
    { u8"𝓃", u8"nscr" },
    { u8"∤", u8"nshortmid" },
    { u8"∦", u8"nshortparallel" },
    { u8"≁", u8"nsim" },
    { u8"≄", u8"nsime" },
    { u8"≄", u8"nsimeq" },
    { u8"∤", u8"nsmid" },
    { u8"∦", u8"nspar" },
    { u8"⋢", u8"nsqsube" },
    { u8"⋣", u8"nsqsupe" },
    { u8"⊄", u8"nsub" },
    { u8"⫅̸", u8"nsubE" },
    { u8"⊈", u8"nsube" },
    { u8"⊂⃒", u8"nsubset" },
    { u8"⊈", u8"nsubseteq" },
    { u8"⫅̸", u8"nsubseteqq" },
    { u8"⊁", u8"nsucc" },
    { u8"⪰̸", u8"nsucceq" },
    { u8"⊅", u8"nsup" },
    { u8"⫆̸", u8"nsupE" },
    { u8"⊉", u8"nsupe" },
    { u8"⊃⃒", u8"nsupset" },
    { u8"⊉", u8"nsupseteq" },
    { u8"⫆̸", u8"nsupseteqq" },
    { u8"≹", u8"ntgl" },
    { u8"Ñ", u8"Ntilde" },
    { u8"ñ", u8"ntilde" },
    { u8"≸", u8"ntlg" },
    { u8"⋪", u8"ntriangleleft" },
    { u8"⋬", u8"ntrianglelefteq" },
    { u8"⋫", u8"ntriangleright" },
    { u8"⋭", u8"ntrianglerighteq" },
    { u8"Ν", u8"Nu" },
    { u8"ν", u8"nu" },
    { u8"#", u8"num", false },
    { u8"№", u8"numero" },
    { u8" ", u8"numsp" },
    { u8"≍⃒", u8"nvap" },
    { u8"⊯", u8"nVDash" },
    { u8"⊮", u8"nVdash" },
    { u8"⊭", u8"nvDash" },
    { u8"⊬", u8"nvdash" },
    { u8"≥⃒", u8"nvge" },
    { u8">⃒", u8"nvgt" },
    { u8"⤄", u8"nvHarr" },
    { u8"⧞", u8"nvinfin" },
    { u8"⤂", u8"nvlArr" },
    { u8"≤⃒", u8"nvle" },
    { u8"<⃒", u8"nvlt" },
    { u8"⊴⃒", u8"nvltrie" },
    { u8"⤃", u8"nvrArr" },
    { u8"⊵⃒", u8"nvrtrie" },
    { u8"∼⃒", u8"nvsim" },
    { u8"⤣", u8"nwarhk" },
    { u8"⇖", u8"nwArr" },
    { u8"↖", u8"nwarr" },
    { u8"↖", u8"nwarrow" },
    { u8"⤧", u8"nwnear" },
    { u8"Ó", u8"Oacute" },
    { u8"ó", u8"oacute" },
    { u8"⊛", u8"oast" },
    { u8"⊚", u8"ocir" },
    { u8"Ô", u8"Ocirc" },
    { u8"ô", u8"ocirc" },
    { u8"О", u8"Ocy" },
    { u8"о", u8"ocy" },
    { u8"⊝", u8"odash" },
    { u8"Ő", u8"Odblac" },
    { u8"ő", u8"odblac" },
    { u8"⨸", u8"odiv" },
    { u8"⊙", u8"odot" },
    { u8"⦼", u8"odsold" },
    { u8"Œ", u8"OElig" },
    { u8"œ", u8"oelig" },
    { u8"⦿", u8"ofcir" },
    { u8"𝔒", u8"Ofr" },
    { u8"𝔬", u8"ofr" },
    { u8"˛", u8"ogon" },
    { u8"Ò", u8"Ograve" },
    { u8"ò", u8"ograve" },
    { u8"⧁", u8"ogt" },
    { u8"⦵", u8"ohbar" },
    { u8"Ω", u8"ohm" },
    { u8"∮", u8"oint" },
    { u8"↺", u8"olarr" },
    { u8"⦾", u8"olcir" },
    { u8"⦻", u8"olcross" },
    { u8"‾", u8"oline" },
    { u8"⧀", u8"olt" },
    { u8"Ō", u8"Omacr" },
    { u8"ō", u8"omacr" },
    { u8"Ω", u8"Omega" },
    { u8"ω", u8"omega" },
    { u8"Ο", u8"Omicron" },
    { u8"ο", u8"omicron" },
    { u8"⦶", u8"omid" },
    { u8"⊖", u8"ominus" },
    { u8"𝕆", u8"Oopf" },
    { u8"𝕠", u8"oopf" },
    { u8"⦷", u8"opar" },
    { u8"“", u8"OpenCurlyDoubleQuote" },
    { u8"‘", u8"OpenCurlyQuote" },
    { u8"⦹", u8"operp" },
    { u8"⊕", u8"oplus" },
    { u8"⩔", u8"Or" },
    { u8"∨", u8"or" },
    { u8"↻", u8"orarr" },
    { u8"⩝", u8"ord" },
    { u8"ℴ", u8"order" },
    { u8"ℴ", u8"orderof" },
    { u8"ª", u8"ordf" },
    { u8"º", u8"ordm" },
    { u8"⊶", u8"origof" },
    { u8"⩖", u8"oror" },
    { u8"⩗", u8"orslope" },
    { u8"⩛", u8"orv" },
    { u8"Ⓢ", u8"oS" },
    { u8"𝒪", u8"Oscr" },
    { u8"ℴ", u8"oscr" },
    { u8"Ø", u8"Oslash" },
    { u8"ø", u8"oslash" },
    { u8"⊘", u8"osol" },
    { u8"Õ", u8"Otilde" },
    { u8"õ", u8"otilde" },
    { u8"⨷", u8"Otimes" },
    { u8"⊗", u8"otimes" },
    { u8"⨶", u8"otimesas" },
    { u8"Ö", u8"Ouml" },
    { u8"ö", u8"ouml" },
    { u8"⌽", u8"ovbar" },
    { u8"‾", u8"OverBar" },
    { u8"⏞", u8"OverBrace" },
    { u8"⎴", u8"OverBracket" },
    { u8"⏜", u8"OverParenthesis" },
    { u8"∥", u8"par" },
    { u8"¶", u8"para" },
    { u8"∥", u8"parallel" },
    { u8"⫳", u8"parsim" },
    { u8"⫽", u8"parsl" },
    { u8"∂", u8"part" },
    { u8"∂", u8"PartialD" },
    { u8"П", u8"Pcy" },
    { u8"п", u8"pcy" },
    { u8"%", u8"percnt", false },
    { u8".", u8"period", false },
    { u8"‰", u8"permil" },
    { u8"⊥", u8"perp" },
    { u8"‱", u8"pertenk" },
    { u8"𝔓", u8"Pfr" },
    { u8"𝔭", u8"pfr" },
    { u8"Φ", u8"Phi" },
    { u8"φ", u8"phi" },
    { u8"ϕ", u8"phiv" },
    { u8"ℳ", u8"phmmat" },
    { u8"☎", u8"phone" },
    { u8"Π", u8"Pi" },
    { u8"π", u8"pi" },
    { u8"⋔", u8"pitchfork" },
    { u8"ϖ", u8"piv" },
    { u8"ℏ", u8"planck" },
    { u8"ℎ", u8"planckh" },
    { u8"ℏ", u8"plankv" },
    { u8"+", u8"plus", false },
    { u8"⨣", u8"plusacir" },
    { u8"⊞", u8"plusb" },
    { u8"⨢", u8"pluscir" },
    { u8"∔", u8"plusdo" },
    { u8"⨥", u8"plusdu" },
    { u8"⩲", u8"pluse" },
    { u8"±", u8"PlusMinus" },
    { u8"±", u8"plusmn" },
    { u8"⨦", u8"plussim" },
    { u8"⨧", u8"plustwo" },
    { u8"±", u8"pm" },
    { u8"ℌ", u8"Poincareplane" },
    { u8"⨕", u8"pointint" },
    { u8"ℙ", u8"Popf" },
    { u8"𝕡", u8"popf" },
    { u8"£", u8"pound" },
    { u8"⪻", u8"Pr" },
    { u8"≺", u8"pr" },
    { u8"⪷", u8"prap" },
    { u8"≼", u8"prcue" },
    { u8"⪳", u8"prE" },
    { u8"⪯", u8"pre" },
    { u8"≺", u8"prec" },
    { u8"⪷", u8"precapprox" },
    { u8"≼", u8"preccurlyeq" },
    { u8"≺", u8"Precedes" },
    { u8"⪯", u8"PrecedesEqual" },
    { u8"≼", u8"PrecedesSlantEqual" },
    { u8"≾", u8"PrecedesTilde" },
    { u8"⪯", u8"preceq" },
    { u8"⪹", u8"precnapprox" },
    { u8"⪵", u8"precneqq" },
    { u8"⋨", u8"precnsim" },
    { u8"≾", u8"precsim" },
    { u8"″", u8"Prime" },
    { u8"′", u8"prime" },
    { u8"ℙ", u8"primes" },
    { u8"⪹", u8"prnap" },
    { u8"⪵", u8"prnE" },
    { u8"⋨", u8"prnsim" },
    { u8"∏", u8"prod" },
    { u8"∏", u8"Product" },
    { u8"⌮", u8"profalar" },
    { u8"⌒", u8"profline" },
    { u8"⌓", u8"profsurf" },
    { u8"∝", u8"prop" },
    { u8"∷", u8"Proportion" },
    { u8"∝", u8"Proportional" },
    { u8"∝", u8"propto" },
    { u8"≾", u8"prsim" },
    { u8"⊰", u8"prurel" },
    { u8"𝒫", u8"Pscr" },
    { u8"𝓅", u8"pscr" },
    { u8"Ψ", u8"Psi" },
    { u8"ψ", u8"psi" },
    { u8" ", u8"puncsp" },
    { u8"𝔔", u8"Qfr" },
    { u8"𝔮", u8"qfr" },
    { u8"⨌", u8"qint" },
    { u8"ℚ", u8"Qopf" },
    { u8"𝕢", u8"qopf" },
    { u8"⁗", u8"qprime" },
    { u8"𝒬", u8"Qscr" },
    { u8"𝓆", u8"qscr" },
    { u8"ℍ", u8"quaternions" },
    { u8"⨖", u8"quatint" },
    { u8"?", u8"quest", false },
    { u8"≟", u8"questeq" },
    { u8"\"", u8"QUOT", false },
    { u8"\"", u8"quot", false },
    { u8"⇛", u8"rAarr" },
    { u8"∽̱", u8"race" },
    { u8"Ŕ", u8"Racute" },
    { u8"ŕ", u8"racute" },
    { u8"√", u8"radic" },
    { u8"⦳", u8"raemptyv" },
    { u8"⟫", u8"Rang" },
    { u8"⟩", u8"rang" },
    { u8"⦒", u8"rangd" },
    { u8"⦥", u8"range" },
    { u8"⟩", u8"rangle" },
    { u8"»", u8"raquo" },
    { u8"↠", u8"Rarr" },
    { u8"⇒", u8"rArr" },
    { u8"→", u8"rarr" },
    { u8"⥵", u8"rarrap" },
    { u8"⇥", u8"rarrb" },
    { u8"⤠", u8"rarrbfs" },
    { u8"⤳", u8"rarrc" },
    { u8"⤞", u8"rarrfs" },
    { u8"↪", u8"rarrhk" },
    { u8"↬", u8"rarrlp" },
    { u8"⥅", u8"rarrpl" },
    { u8"⥴", u8"rarrsim" },
    { u8"⤖", u8"Rarrtl" },
    { u8"↣", u8"rarrtl" },
    { u8"↝", u8"rarrw" },
    { u8"⤜", u8"rAtail" },
    { u8"⤚", u8"ratail" },
    { u8"∶", u8"ratio" },
    { u8"ℚ", u8"rationals" },
    { u8"⤐", u8"RBarr" },
    { u8"⤏", u8"rBarr" },
    { u8"⤍", u8"rbarr" },
    { u8"❳", u8"rbbrk" },
    { u8"}", u8"rbrace", false },
    { u8"]", u8"rbrack", false },
    { u8"⦌", u8"rbrke" },
    { u8"⦎", u8"rbrksld" },
    { u8"⦐", u8"rbrkslu" },
    { u8"Ř", u8"Rcaron" },
    { u8"ř", u8"rcaron" },
    { u8"Ŗ", u8"Rcedil" },
    { u8"ŗ", u8"rcedil" },
    { u8"⌉", u8"rceil" },
    { u8"}", u8"rcub", false },
    { u8"Р", u8"Rcy" },
    { u8"р", u8"rcy" },
    { u8"⤷", u8"rdca" },
    { u8"⥩", u8"rdldhar" },
    { u8"”", u8"rdquo" },
    { u8"”", u8"rdquor" },
    { u8"↳", u8"rdsh" },
    { u8"ℜ", u8"Re" },
    { u8"ℜ", u8"real" },
    { u8"ℛ", u8"realine" },
    { u8"ℜ", u8"realpart" },
    { u8"ℝ", u8"reals" },
    { u8"▭", u8"rect" },
    { u8"®", u8"REG" },
    { u8"®", u8"reg" },
    { u8"∋", u8"ReverseElement" },
    { u8"⇋", u8"ReverseEquilibrium" },
    { u8"⥯", u8"ReverseUpEquilibrium" },
    { u8"⥽", u8"rfisht" },
    { u8"⌋", u8"rfloor" },
    { u8"ℜ", u8"Rfr" },
    { u8"𝔯", u8"rfr" },
    { u8"⥤", u8"rHar" },
    { u8"⇁", u8"rhard" },
    { u8"⇀", u8"rharu" },
    { u8"⥬", u8"rharul" },
    { u8"Ρ", u8"Rho" },
    { u8"ρ", u8"rho" },
    { u8"ϱ", u8"rhov" },
    { u8"⟩", u8"RightAngleBracket" },
    { u8"→", u8"RightArrow" },
    { u8"⇒", u8"Rightarrow" },
    { u8"→", u8"rightarrow" },
    { u8"⇥", u8"RightArrowBar" },
    { u8"⇄", u8"RightArrowLeftArrow" },
    { u8"↣", u8"rightarrowtail" },
    { u8"⌉", u8"RightCeiling" },
    { u8"⟧", u8"RightDoubleBracket" },
    { u8"⥝", u8"RightDownTeeVector" },
    { u8"⇂", u8"RightDownVector" },
    { u8"⥕", u8"RightDownVectorBar" },
    { u8"⌋", u8"RightFloor" },
    { u8"⇁", u8"rightharpoondown" },
    { u8"⇀", u8"rightharpoonup" },
    { u8"⇄", u8"rightleftarrows" },
    { u8"⇌", u8"rightleftharpoons" },
    { u8"⇉", u8"rightrightarrows" },
    { u8"↝", u8"rightsquigarrow" },
    { u8"⊢", u8"RightTee" },
    { u8"↦", u8"RightTeeArrow" },
    { u8"⥛", u8"RightTeeVector" },
    { u8"⋌", u8"rightthreetimes" },
    { u8"⊳", u8"RightTriangle" },
    { u8"⧐", u8"RightTriangleBar" },
    { u8"⊵", u8"RightTriangleEqual" },
    { u8"⥏", u8"RightUpDownVector" },
    { u8"⥜", u8"RightUpTeeVector" },
    { u8"↾", u8"RightUpVector" },
    { u8"⥔", u8"RightUpVectorBar" },
    { u8"⇀", u8"RightVector" },
    { u8"⥓", u8"RightVectorBar" },
    { u8"˚", u8"ring" },
    { u8"≓", u8"risingdotseq" },
    { u8"⇄", u8"rlarr" },
    { u8"⇌", u8"rlhar" },
    { u8"‏", u8"rlm" },
    { u8"⎱", u8"rmoust" },
    { u8"⎱", u8"rmoustache" },
    { u8"⫮", u8"rnmid" },
    { u8"⟭", u8"roang" },
    { u8"⇾", u8"roarr" },
    { u8"⟧", u8"robrk" },
    { u8"⦆", u8"ropar" },
    { u8"ℝ", u8"Ropf" },
    { u8"𝕣", u8"ropf" },
    { u8"⨮", u8"roplus" },
    { u8"⨵", u8"rotimes" },
    { u8"⥰", u8"RoundImplies" },
    { u8")", u8"rpar", false },
    { u8"⦔", u8"rpargt" },
    { u8"⨒", u8"rppolint" },
    { u8"⇉", u8"rrarr" },
    { u8"⇛", u8"Rrightarrow" },
    { u8"›", u8"rsaquo" },
    { u8"ℛ", u8"Rscr" },
    { u8"𝓇", u8"rscr" },
    { u8"↱", u8"Rsh" },
    { u8"↱", u8"rsh" },
    { u8"]", u8"rsqb", false },
    { u8"’", u8"rsquo" },
    { u8"’", u8"rsquor" },
    { u8"⋌", u8"rthree" },
    { u8"⋊", u8"rtimes" },
    { u8"▹", u8"rtri" },
    { u8"⊵", u8"rtrie" },
    { u8"▸", u8"rtrif" },
    { u8"⧎", u8"rtriltri" },
    { u8"⧴", u8"RuleDelayed" },
    { u8"⥨", u8"ruluhar" },
    { u8"℞", u8"rx" },
    { u8"Ś", u8"Sacute" },
    { u8"ś", u8"sacute" },
    { u8"‚", u8"sbquo" },
    { u8"⪼", u8"Sc" },
    { u8"≻", u8"sc" },
    { u8"⪸", u8"scap" },
    { u8"Š", u8"Scaron" },
    { u8"š", u8"scaron" },
    { u8"≽", u8"sccue" },
    { u8"⪴", u8"scE" },
    { u8"⪰", u8"sce" },
    { u8"Ş", u8"Scedil" },
    { u8"ş", u8"scedil" },
    { u8"Ŝ", u8"Scirc" },
    { u8"ŝ", u8"scirc" },
    { u8"⪺", u8"scnap" },
    { u8"⪶", u8"scnE" },
    { u8"⋩", u8"scnsim" },
    { u8"⨓", u8"scpolint" },
    { u8"≿", u8"scsim" },
    { u8"С", u8"Scy" },
    { u8"с", u8"scy" },
    { u8"⋅", u8"sdot" },
    { u8"⊡", u8"sdotb" },
    { u8"⩦", u8"sdote" },
    { u8"⤥", u8"searhk" },
    { u8"⇘", u8"seArr" },
    { u8"↘", u8"searr" },
    { u8"↘", u8"searrow" },
    { u8"§", u8"sect" },
    { u8";", u8"semi", false },
    { u8"⤩", u8"seswar" },
    { u8"∖", u8"setminus" },
    { u8"∖", u8"setmn" },
    { u8"✶", u8"sext" },
    { u8"𝔖", u8"Sfr" },
    { u8"𝔰", u8"sfr" },
    { u8"⌢", u8"sfrown" },
    { u8"♯", u8"sharp" },
    { u8"Щ", u8"SHCHcy" },
    { u8"щ", u8"shchcy" },
    { u8"Ш", u8"SHcy" },
    { u8"ш", u8"shcy" },
    { u8"↓", u8"ShortDownArrow" },
    { u8"←", u8"ShortLeftArrow" },
    { u8"∣", u8"shortmid" },
    { u8"∥", u8"shortparallel" },
    { u8"→", u8"ShortRightArrow" },
    { u8"↑", u8"ShortUpArrow" },
    { u8"­", u8"shy" },
    { u8"Σ", u8"Sigma" },
    { u8"σ", u8"sigma" },
    { u8"ς", u8"sigmaf" },
    { u8"ς", u8"sigmav" },
    { u8"∼", u8"sim" },
    { u8"⩪", u8"simdot" },
    { u8"≃", u8"sime" },
    { u8"≃", u8"simeq" },
    { u8"⪞", u8"simg" },
    { u8"⪠", u8"simgE" },
    { u8"⪝", u8"siml" },
    { u8"⪟", u8"simlE" },
    { u8"≆", u8"simne" },
    { u8"⨤", u8"simplus" },
    { u8"⥲", u8"simrarr" },
    { u8"←", u8"slarr" },
    { u8"∘", u8"SmallCircle" },
    { u8"∖", u8"smallsetminus" },
    { u8"⨳", u8"smashp" },
    { u8"⧤", u8"smeparsl" },
    { u8"∣", u8"smid" },
    { u8"⌣", u8"smile" },
    { u8"⪪", u8"smt" },
    { u8"⪬", u8"smte" },
    { u8"⪬︀", u8"smtes" },
    { u8"Ь", u8"SOFTcy" },
    { u8"ь", u8"softcy" },
    { u8"/", u8"sol", false },
    { u8"⧄", u8"solb" },
    { u8"⌿", u8"solbar" },
    { u8"𝕊", u8"Sopf" },
    { u8"𝕤", u8"sopf" },
    { u8"♠", u8"spades" },
    { u8"♠", u8"spadesuit" },
    { u8"∥", u8"spar" },
    { u8"*", u8"splat", false },
    { u8"⊓", u8"sqcap" },
    { u8"⊓︀", u8"sqcaps" },
    { u8"⊔", u8"sqcup" },
    { u8"⊔︀", u8"sqcups" },
    { u8"~", u8"squiggle", false },
    { u8"√", u8"Sqrt" },
    { u8"⊏", u8"sqsub" },
    { u8"⊑", u8"sqsube" },
    { u8"⊏", u8"sqsubset" },
    { u8"⊑", u8"sqsubseteq" },
    { u8"⊐", u8"sqsup" },
    { u8"⊒", u8"sqsupe" },
    { u8"⊐", u8"sqsupset" },
    { u8"⊒", u8"sqsupseteq" },
    { u8"□", u8"squ" },
    { u8"□", u8"Square" },
    { u8"□", u8"square" },
    { u8"⊓", u8"SquareIntersection" },
    { u8"⊏", u8"SquareSubset" },
    { u8"⊑", u8"SquareSubsetEqual" },
    { u8"⊐", u8"SquareSuperset" },
    { u8"⊒", u8"SquareSupersetEqual" },
    { u8"⊔", u8"SquareUnion" },
    { u8"▪", u8"squarf" },
    { u8"▪", u8"squf" },
    { u8"→", u8"srarr" },
    { u8"𝒮", u8"Sscr" },
    { u8"𝓈", u8"sscr" },
    { u8"∖", u8"ssetmn" },
    { u8"⌣", u8"ssmile" },
    { u8"⋆", u8"sstarf" },
    { u8"⋆", u8"Star" },
    { u8"☆", u8"star" },
    { u8"★", u8"starf" },
    { u8"ϵ", u8"straightepsilon" },
    { u8"ϕ", u8"straightphi" },
    { u8"¯", u8"strns" },
    { u8"⋐", u8"Sub" },
    { u8"⊂", u8"sub" },
    { u8"⪽", u8"subdot" },
    { u8"⫅", u8"subE" },
    { u8"⊆", u8"sube" },
    { u8"⫃", u8"subedot" },
    { u8"⫁", u8"submult" },
    { u8"⫋", u8"subnE" },
    { u8"⊊", u8"subne" },
    { u8"⪿", u8"subplus" },
    { u8"⥹", u8"subrarr" },
    { u8"⋐", u8"Subset" },
    { u8"⊂", u8"subset" },
    { u8"⊆", u8"subseteq" },
    { u8"⫅", u8"subseteqq" },
    { u8"⊆", u8"SubsetEqual" },
    { u8"⊊", u8"subsetneq" },
    { u8"⫋", u8"subsetneqq" },
    { u8"⫇", u8"subsim" },
    { u8"⫕", u8"subsub" },
    { u8"⫓", u8"subsup" },
    { u8"≻", u8"succ" },
    { u8"⪸", u8"succapprox" },
    { u8"≽", u8"succcurlyeq" },
    { u8"≻", u8"Succeeds" },
    { u8"⪰", u8"SucceedsEqual" },
    { u8"≽", u8"SucceedsSlantEqual" },
    { u8"≿", u8"SucceedsTilde" },
    { u8"⪰", u8"succeq" },
    { u8"⪺", u8"succnapprox" },
    { u8"⪶", u8"succneqq" },
    { u8"⋩", u8"succnsim" },
    { u8"≿", u8"succsim" },
    { u8"∋", u8"SuchThat" },
    { u8"∑", u8"Sum" },
    { u8"∑", u8"sum" },
    { u8"♪", u8"sung" },
    { u8"⋑", u8"Sup" },
    { u8"⊃", u8"sup" },
    { u8"¹", u8"sup1" },
    { u8"²", u8"sup2" },
    { u8"³", u8"sup3" },
    { u8"⪾", u8"supdot" },
    { u8"⫘", u8"supdsub" },
    { u8"⫆", u8"supE" },
    { u8"⊇", u8"supe" },
    { u8"⫄", u8"supedot" },
    { u8"⊃", u8"Superset" },
    { u8"⊇", u8"SupersetEqual" },
    { u8"⟉", u8"suphsol" },
    { u8"⫗", u8"suphsub" },
    { u8"⥻", u8"suplarr" },
    { u8"⫂", u8"supmult" },
    { u8"⫌", u8"supnE" },
    { u8"⊋", u8"supne" },
    { u8"⫀", u8"supplus" },
    { u8"⋑", u8"Supset" },
    { u8"⊃", u8"supset" },
    { u8"⊇", u8"supseteq" },
    { u8"⫆", u8"supseteqq" },
    { u8"⊋", u8"supsetneq" },
    { u8"⫌", u8"supsetneqq" },
    { u8"⫈", u8"supsim" },
    { u8"⫔", u8"supsub" },
    { u8"⫖", u8"supsup" },
    { u8"⤦", u8"swarhk" },
    { u8"⇙", u8"swArr" },
    { u8"↙", u8"swarr" },
    { u8"↙", u8"swarrow" },
    { u8"⤪", u8"swnwar" },
    { u8"ß", u8"szlig" },
    { u8"␉", u8"Tab" },
    { u8"⌖", u8"target" },
    { u8"Τ", u8"Tau" },
    { u8"τ", u8"tau" },
    { u8"⎴", u8"tbrk" },
    { u8"Ť", u8"Tcaron" },
    { u8"ť", u8"tcaron" },
    { u8"Ţ", u8"Tcedil" },
    { u8"ţ", u8"tcedil" },
    { u8"Т", u8"Tcy" },
    { u8"т", u8"tcy" },
    { u8"◌⃛", u8"tdot" },
    { u8"⌕", u8"telrec" },
    { u8"𝔗", u8"Tfr" },
    { u8"𝔱", u8"tfr" },
    { u8"∴", u8"there4" },
    { u8"∴", u8"Therefore" },
    { u8"∴", u8"therefore" },
    { u8"Θ", u8"Theta" },
    { u8"θ", u8"theta" },
    { u8"ϑ", u8"thetasym" },
    { u8"ϑ", u8"thetav" },
    { u8"≈", u8"thickapprox" },
    { u8"∼", u8"thicksim" },
    { u8"  ", u8"ThickSpace" },
    { u8" ", u8"thinsp" },
    { u8" ", u8"ThinSpace" },
    { u8"≈", u8"thkap" },
    { u8"∼", u8"thksim" },
    { u8"þ", u8"thorn" },
    { u8"Þ", u8"THORN" },
    { u8"∼", u8"Tilde" },
    { u8"˜", u8"tilde" },
    { u8"≃", u8"TildeEqual" },
    { u8"≅", u8"TildeFullEqual" },
    { u8"≈", u8"TildeTilde" },
    { u8"×", u8"times" },
    { u8"⊠", u8"timesb" },
    { u8"⨱", u8"timesbar" },
    { u8"⨰", u8"timesd" },
    { u8"∭", u8"tint" },
    { u8"⤨", u8"toea" },
    { u8"⊤", u8"top" },
    { u8"⌶", u8"topbot" },
    { u8"⫱", u8"topcir" },
    { u8"𝕋", u8"Topf" },
    { u8"𝕥", u8"topf" },
    { u8"⫚", u8"topfork" },
    { u8"⤩", u8"tosa" },
    { u8"‴", u8"tprime" },
    { u8"™", u8"trade" },
    { u8"™", u8"TRADE" },
    { u8"▵", u8"triangle" },
    { u8"▿", u8"triangledown" },
    { u8"◃", u8"triangleleft" },
    { u8"⊴", u8"trianglelefteq" },
    { u8"≜", u8"triangleq" },
    { u8"▹", u8"triangleright" },
    { u8"⊵", u8"trianglerighteq" },
    { u8"◬", u8"tridot" },
    { u8"≜", u8"trie" },
    { u8"⨺", u8"triminus" },
    { u8"◌⃛", u8"TripleDot" },
    { u8"⨹", u8"triplus" },
    { u8"⧍", u8"trisb" },
    { u8"⨻", u8"tritime" },
    { u8"⏢", u8"trpezium" },
    { u8"𝒯", u8"Tscr" },
    { u8"𝓉", u8"tscr" },
    { u8"Ц", u8"TScy" },
    { u8"ц", u8"tscy" },
    { u8"Ћ", u8"TSHcy" },
    { u8"ћ", u8"tshcy" },
    { u8"Ŧ", u8"Tstrok" },
    { u8"ŧ", u8"tstrok" },
    { u8"≬", u8"twixt" },
    { u8"↞", u8"twoheadleftarrow" },
    { u8"↠", u8"twoheadrightarrow" },
    { u8"Ú", u8"Uacute" },
    { u8"ú", u8"uacute" },
    { u8"↟", u8"Uarr" },
    { u8"⇑", u8"uArr" },
    { u8"↑", u8"uarr" },
    { u8"⥉", u8"Uarrocir" },
    { u8"Ў", u8"Ubrcy" },
    { u8"ў", u8"ubrcy" },
    { u8"Ŭ", u8"Ubreve" },
    { u8"ŭ", u8"ubreve" },
    { u8"Û", u8"Ucirc" },
    { u8"û", u8"ucirc" },
    { u8"У", u8"Ucy" },
    { u8"у", u8"ucy" },
    { u8"⇅", u8"udarr" },
    { u8"Ű", u8"Udblac" },
    { u8"ű", u8"udblac" },
    { u8"⥮", u8"udhar" },
    { u8"⥾", u8"ufisht" },
    { u8"𝔘", u8"Ufr" },
    { u8"𝔲", u8"ufr" },
    { u8"Ù", u8"Ugrave" },
    { u8"ù", u8"ugrave" },
    { u8"⥣", u8"uHar" },
    { u8"↿", u8"uharl" },
    { u8"↾", u8"uharr" },
    { u8"▀", u8"uhblk" },
    { u8"⌜", u8"ulcorn" },
    { u8"⌜", u8"ulcorner" },
    { u8"⌏", u8"ulcrop" },
    { u8"◸", u8"ultri" },
    { u8"Ū", u8"Umacr" },
    { u8"ū", u8"umacr" },
    { u8"¨", u8"uml" },
    { u8"_", u8"UnderBar", false },
    { u8"⏟", u8"UnderBrace" },
    { u8"⎵", u8"UnderBracket" },
    { u8"⏝", u8"UnderParenthesis" },
    { u8"⋃", u8"Union" },
    { u8"⊎", u8"UnionPlus" },
    { u8"Ų", u8"Uogon" },
    { u8"ų", u8"uogon" },
    { u8"𝕌", u8"Uopf" },
    { u8"𝕦", u8"uopf" },
    { u8"↑", u8"UpArrow" },
    { u8"⇑", u8"Uparrow" },
    { u8"↑", u8"uparrow" },
    { u8"⤒", u8"UpArrowBar" },
    { u8"⇅", u8"UpArrowDownArrow" },
    { u8"↕", u8"UpDownArrow" },
    { u8"⇕", u8"Updownarrow" },
    { u8"↕", u8"updownarrow" },
    { u8"⥮", u8"UpEquilibrium" },
    { u8"↿", u8"upharpoonleft" },
    { u8"↾", u8"upharpoonright" },
    { u8"⊎", u8"uplus" },
    { u8"↖", u8"UpperLeftArrow" },
    { u8"↗", u8"UpperRightArrow" },
    { u8"ϒ", u8"Upsi" },
    { u8"υ", u8"upsi" },
    { u8"ϒ", u8"upsih" },
    { u8"Υ", u8"Upsilon" },
    { u8"υ", u8"upsilon" },
    { u8"⊥", u8"UpTee" },
    { u8"↥", u8"UpTeeArrow" },
    { u8"⇈", u8"upuparrows" },
    { u8"⌝", u8"urcorn" },
    { u8"⌝", u8"urcorner" },
    { u8"⌎", u8"urcrop" },
    { u8"Ů", u8"Uring" },
    { u8"ů", u8"uring" },
    { u8"◹", u8"urtri" },
    { u8"𝒰", u8"Uscr" },
    { u8"𝓊", u8"uscr" },
    { u8"⋰", u8"utdot" },
    { u8"Ũ", u8"Utilde" },
    { u8"ũ", u8"utilde" },
    { u8"▵", u8"utri" },
    { u8"▴", u8"utrif" },
    { u8"⇈", u8"uuarr" },
    { u8"Ü", u8"Uuml" },
    { u8"ü", u8"uuml" },
    { u8"⦧", u8"uwangle" },
    { u8"⦜", u8"vangrt" },
    { u8"ϵ", u8"varepsilon" },
    { u8"ϰ", u8"varkappa" },
    { u8"∅", u8"varnothing" },
    { u8"ϕ", u8"varphi" },
    { u8"ϖ", u8"varpi" },
    { u8"∝", u8"varpropto" },
    { u8"⇕", u8"vArr" },
    { u8"↕", u8"varr" },
    { u8"ϱ", u8"varrho" },
    { u8"ς", u8"varsigma" },
    { u8"⊊︀", u8"varsubsetneq" },
    { u8"⫋︀", u8"varsubsetneqq" },
    { u8"⊋︀", u8"varsupsetneq" },
    { u8"⫌︀", u8"varsupsetneqq" },
    { u8"ϑ", u8"vartheta" },
    { u8"⊲", u8"vartriangleleft" },
    { u8"⊳", u8"vartriangleright" },
    { u8"⫫", u8"Vbar" },
    { u8"⫨", u8"vBar" },
    { u8"⫩", u8"vBarv" },
    { u8"В", u8"Vcy" },
    { u8"в", u8"vcy" },
    { u8"⊫", u8"VDash" },
    { u8"⊩", u8"Vdash" },
    { u8"⊨", u8"vDash" },
    { u8"⊢", u8"vdash" },
    { u8"⫦", u8"Vdashl" },
    { u8"⋁", u8"Vee" },
    { u8"∨", u8"vee" },
    { u8"⊻", u8"veebar" },
    { u8"≚", u8"veeeq" },
    { u8"⋮", u8"vellip" },
    { u8"‖", u8"Verbar" },
    { u8"|", u8"verbar", false },
    { u8"‖", u8"Vert" },
    { u8"|", u8"vert", false },
    { u8"∣", u8"VerticalBar" },
    { u8"|", u8"VerticalLine", false },
    { u8"❘", u8"VerticalSeparator" },
    { u8"≀", u8"VerticalTilde" },
    { u8" ", u8"VeryThinSpace" },
    { u8"𝔙", u8"Vfr" },
    { u8"𝔳", u8"vfr" },
    { u8"⊲", u8"vltri" },
    { u8"⊂⃒", u8"vnsub" },
    { u8"⊃⃒", u8"vnsup" },
    { u8"𝕍", u8"Vopf" },
    { u8"𝕧", u8"vopf" },
    { u8"∝", u8"vprop" },
    { u8"⊳", u8"vrtri" },
    { u8"𝒱", u8"Vscr" },
    { u8"𝓋", u8"vscr" },
    { u8"⫋︀", u8"vsubnE" },
    { u8"⊊︀", u8"vsubne" },
    { u8"⫌︀", u8"vsupnE" },
    { u8"⊋︀", u8"vsupne" },
    { u8"⊪", u8"Vvdash" },
    { u8"⦚", u8"vzigzag" },
    { u8"Ŵ", u8"Wcirc" },
    { u8"ŵ", u8"wcirc" },
    { u8"⩟", u8"wedbar" },
    { u8"⋀", u8"Wedge" },
    { u8"∧", u8"wedge" },
    { u8"≙", u8"wedgeq" },
    { u8"℘", u8"weierp" },
    { u8"𝔚", u8"Wfr" },
    { u8"𝔴", u8"wfr" },
    { u8"𝕎", u8"Wopf" },
    { u8"𝕨", u8"wopf" },
    { u8"℘", u8"wp" },
    { u8"≀", u8"wr" },
    { u8"≀", u8"wreath" },
    { u8"𝒲", u8"Wscr" },
    { u8"𝓌", u8"wscr" },
    { u8"⋂", u8"xcap" },
    { u8"◯", u8"xcirc" },
    { u8"⋃", u8"xcup" },
    { u8"▽", u8"xdtri" },
    { u8"𝔛", u8"Xfr" },
    { u8"𝔵", u8"xfr" },
    { u8"⟺", u8"xhArr" },
    { u8"⟷", u8"xharr" },
    { u8"Ξ", u8"Xi" },
    { u8"ξ", u8"xi" },
    { u8"⟸", u8"xlArr" },
    { u8"⟵", u8"xlarr" },
    { u8"⟼", u8"xmap" },
    { u8"⋻", u8"xnis" },
    { u8"⨀", u8"xodot" },
    { u8"𝕏", u8"Xopf" },
    { u8"𝕩", u8"xopf" },
    { u8"⨁", u8"xoplus" },
    { u8"⨂", u8"xotime" },
    { u8"⟹", u8"xrArr" },
    { u8"⟶", u8"xrarr" },
    { u8"𝒳", u8"Xscr" },
    { u8"𝓍", u8"xscr" },
    { u8"⨆", u8"xsqcup" },
    { u8"⨄", u8"xuplus" },
    { u8"△", u8"xutri" },
    { u8"⋁", u8"xvee" },
    { u8"⋀", u8"xwedge" },
    { u8"Ý", u8"Yacute" },
    { u8"ý", u8"yacute" },
    { u8"Я", u8"YAcy" },
    { u8"я", u8"yacy" },
    { u8"Ŷ", u8"Ycirc" },
    { u8"ŷ", u8"ycirc" },
    { u8"Ы", u8"Ycy" },
    { u8"ы", u8"ycy" },
    { u8"¥", u8"yen" },
    { u8"𝔜", u8"Yfr" },
    { u8"𝔶", u8"yfr" },
    { u8"Ї", u8"YIcy" },
    { u8"ї", u8"yicy" },
    { u8"𝕐", u8"Yopf" },
    { u8"𝕪", u8"yopf" },
    { u8"𝒴", u8"Yscr" },
    { u8"𝓎", u8"yscr" },
    { u8"Ю", u8"YUcy" },
    { u8"ю", u8"yucy" },
    { u8"Ÿ", u8"Yuml" },
    { u8"ÿ", u8"yuml" },
    { u8"Ź", u8"Zacute" },
    { u8"ź", u8"zacute" },
    { u8"Ž", u8"Zcaron" },
    { u8"ž", u8"zcaron" },
    { u8"З", u8"Zcy" },
    { u8"з", u8"zcy" },
    { u8"Ż", u8"Zdot" },
    { u8"ż", u8"zdot" },
    { u8"ℨ", u8"zeetrf" },
    { u8"​", u8"ZeroWidthSpace" },
    { u8"Ζ", u8"Zeta" },
    { u8"ζ", u8"zeta" },
    { u8"ℨ", u8"Zfr" },
    { u8"𝔷", u8"zfr" },
    { u8"Ж", u8"ZHcy" },
    { u8"ж", u8"zhcy" },
    { u8"⇝", u8"zigrarr" },
    { u8"ℤ", u8"Zopf" },
    { u8"𝕫", u8"zopf" },
    { u8"𝒵", u8"Zscr" },
    { u8"𝓏", u8"zscr" },
    { u8"‍", u8"zwj" },
    { u8"‌", u8"zwnj" },
    { nullptr, nullptr } };

// WARNING: some symbols may display incorrectly in some editors on some systems: edit them at your peril.
extra_t xtra [] =
{   { u8"™", u8"TM" },
    { u8"…", u8"..." },
    { u8"©", u8"(c)" },
    { u8"©", u8"(C)" },
    { u8"—", u8"---" },
    { u8"⅛", u8"1/8" },
    { u8"⅙", u8"1/6" },
    { u8"⅕", u8"1/5" },
    { u8"¼", u8"1/4" },
    { u8"⅓", u8"1/3" },
    { u8"⅖", u8"2/5" },
    { u8"⅜", u8"3/8" },
    { u8"½", u8"1/2" },
    { u8"⅗", u8"3/5" },
    { u8"⅝", u8"5/8" },
    { u8"⅔", u8"2/3" },
    { u8"¾", u8"3/4" },
    { u8"⅘", u8"4/5" },
    { u8"⅚", u8"5/6" },
    { u8"⅞", u8"7/8" },
    { u8"Æ", u8"AE" },
    { u8"Ǳ", u8"DZ" },
    { u8"ǲ", u8"Dz" },
    { u8"Ĳ", u8"IJ" },
    { u8"Ǉ", u8"LJ" },
    { u8"ǈ", u8"Lj" },
    { u8"Ǌ", u8"NJ" },
    { u8"ǋ", u8"Nj" },
    { u8"Œ", u8"OE" },
    { u8"æ", u8"ae" },
    { u8"ǳ", u8"dz" },
    { u8"ﬃ", u8"ffi" },
    { u8"ﬀ", u8"ff" },
    { u8"ﬄ", u8"ffl" },
    { u8"ﬁ", u8"fi" },
    { u8"fj", u8"fj" },
    { u8"ﬂ", u8"fl" },
    { u8"ĳ", u8"ij" },
    { u8"ǉ", u8"lj" },
    { u8"ǌ", u8"nj" },
    { u8"œ", u8"oe" },
    { u8"ﬂ", u8"fll" },
    { nullptr, nullptr, NOFLAGS } };
